VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsGif24bit"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'Note:
'The Unisys Corporation has a patent that it alleges
'covers certain aspects of GIF-LZW compression technology,
'which the PictureBox and Image controls use.
'Microsoft Corporation obtained a license
'to the Unisys LZW patents in September, 1996.
'Microsoft's license does not, however,
'extend to software developers or third parties
'who use any Microsoft toolkit, language development,
'or operating system products to provide
'GIF read/write and/or any other LZW capabilities
'in their own products (for example, by way of DLLs and APIs).

'If your commercial application uses either of these controls
'(and thus, the LZW technology), you may wish to '
'obtain an independent legal opinion on the effect
'of the patent, or contact
'Unisys USA at http://www.unisys.com/ for more information.

 
' Please make sure you understand the implications of the
' above notes if you release a Commercial product
' using my Gif functions.
' I am NOT responsible for the use of this software.
' Stephen Lebans
' May 6, 2000


' ************************************************
' Sorry, I just don't have time to go back in and
' really clean up this code! :-(
' I've left a few functions in that are not used
' in this version but will be used in the next release.


Option Explicit

' Animated Gif Class Module

'Copyright Lebans Holdings 1999 Ltd.
'You may freely use and redistribute this code providing
'the copyright notice is left intact.
'You may not resell this code as part of a collection or by itself.
'Please feel free to use this code within your own applications,
'whether private or commercial, without cost.
'Contact   Stephen@lebans.com    or visit    www.lebans.com"
 


' Declare our structures for this module
Private Type RECTL
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Private Type SIZEL
    cx As Long
    cy As Long
End Type

Private Type POINTAPI
    x As Long
    y As Long
End Type

Private Type PALETTEENTRY
    peRed As Byte
    peGreen As Byte
    peBlue As Byte
    peFlags As Byte
End Type

' Logical Palette
Private Type LOGPALETTE
    palVersion As Integer
    palNumEntries As Integer
    palPalEntry(1) As PALETTEENTRY
End Type

Private Type RGBQUAD
    RGBBlue As Byte
    RGBGreen As Byte
    RGBRed As Byte
    rgbReserved As Byte
End Type

Private Type BITMAP
    bmType As Long
    bmWidth As Long
    bmHeight As Long
    bmWidthBytes As Long
    bmPlanes As Integer
    bmBitsPixel As Integer
    bmBits As Long
End Type

Private Type BITMAPINFOHEADER '40 bytes
    biSize As Long
    biWidth As Long
    biHeight As Long
    biPlanes As Integer
    biBitCount As Integer
    biCompression As Long
    biSizeImage As Long
    biXPelsPerMeter As Long
    biYPelsPerMeter As Long
    biClrUsed As Long
    biClrImportant As Long
End Type

Private Const NUMPICCOLORS = 255

Private Type BITMAPINFO256
    bmiHeader As BITMAPINFOHEADER
    bmiColors(255) As RGBQUAD ' 8 bit RGB
End Type

Private Type BITMAPINFO2
    bmiHeader As BITMAPINFOHEADER
    bmiColors(0 To 1) As RGBQUAD ' 2 Color RGB
End Type

Private Type BITMAPINFO
    bmiHeader As BITMAPINFOHEADER
    ' No COlors 24 bit RGB
End Type

' Below reTyped - easier to write
Private Type BITMAPFILEHEADER    '14 bytes
    bfType As Integer
    bfSize(3) As Byte 'Long
    'bfSize As Long
    bfReserved1 As Integer
    bfReserved2 As Integer
    'bfOffBits As Long
    bfOffBits(3) As Byte
End Type

Private Type DIBSECTION
    dsBm As BITMAP
    dsBmih As BITMAPINFOHEADER
    dsBitfields(2) As Long
    dshSection As Long
    dsOffset As Long
End Type

Private Const OFS_MAXPATHNAME = 128

' OpenFile() Structure
Private Type OFSTRUCT
    cBytes As Byte
    fFixedDisk As Byte
    nErrCode As Integer
    Reserved1 As Integer
    Reserved2 As Integer
    szPathName(OFS_MAXPATHNAME) As Byte
End Type

Private Type COLORSTRUC
   lStructSize As Long
   hwnd As Long
   hInstance As Long
   rgbResult As Long
   lpCustColors As String
   flags As Long
   lCustData As Long
   lpfnHook As Long
   lpTemplateName As String
 End Type

Private Type SECURITY_ATTRIBUTES
nLength As Long
lpSecurityDescriptor As Long
bInheritHandle As Long
End Type


Private Declare Function GetSysColor Lib "user32" (ByVal nIndex As Long) As Long
Private Declare Function CreateBitmapIndirect Lib "gdi32" (lpBitmap As BITMAP) As Long
Private Declare Function CreateCompatibleBitmap Lib "gdi32" (ByVal hDC As Long, ByVal nWidth As Long, ByVal nHeight As Long) As Long
 
Private Declare Function CreateBitmap Lib "gdi32" _
  (ByVal nWidth As Long, _
   ByVal nHeight As Long, _
   ByVal nPlanes As Long, _
   ByVal nBitCount As Long, _
   lpBits As Any) As Long

Private Declare Function LockWindowUpdate Lib "user32" (ByVal hWndLock As Long) As Long
'Private Declare Function GetPixel Lib "gdi32" (ByVal hDC As Long, ByVal x As Long, ByVal y As Long) As Long
Private Declare Function GetPaletteEntries Lib "gdi32" (ByVal hPalette As Long, ByVal wStartIndex As Long, ByVal wNumEntries As Long, lpPaletteEntries As PALETTEENTRY) As Long
Private Declare Function RealizePalette Lib "gdi32" (ByVal hDC As Long) As Long

Private Declare Function GetDIBColorTable Lib "gdi32" _
(ByVal hDC As Long, ByVal un1 As Long, ByVal un2 As Long, pRGBQuad As RGBQUAD) As Long

Private Declare Function GetCurrentObject Lib "gdi32" _
(ByVal hDC As Long, ByVal uObjectType As Long) As Long

Private Declare Function GetStockObject Lib "gdi32" (ByVal nIndex As Long) As Long
Private Declare Function SetPixel Lib "gdi32" (ByVal hDC As Long, ByVal x As Long, ByVal y As Long, ByVal crColor As Long) As Long

Private Declare Function GetNearestColor Lib "gdi32" (ByVal hDC As Long, ByVal crColor As Long) As Long
Private Declare Function GetNearestPaletteIndex Lib "gdi32" (ByVal hPalette As Long, ByVal crColor As Long) As Long
Private Declare Function CreateHalftonePalette Lib "gdi32" (ByVal hDC As Long) As Long

Private Declare Function SelectPalette Lib "gdi32" (ByVal hDC As Long, ByVal hPalette As Long, ByVal bForceBackground As Long) As Long
Private Declare Function SetBitmapBits Lib "gdi32" ()

Private Declare Function FillRect Lib "user32" _
(ByVal hDC As Long, lpRect As RECTL, ByVal hBrush As Long) As Long

Private Declare Function GetTempPath Lib "kernel32" _
Alias "GetTempPathA" (ByVal nBufferLength As Long, _
ByVal lpBuffer As String) As Long

Private Declare Function GetTempFileName _
  Lib "kernel32" Alias "GetTempFileNameA" _
  (ByVal lpszPath As String, _
  ByVal lpPrefixString As String, _
  ByVal wUnique As Long, _
  ByVal lpTempFileName As String) As Long
 
Private Declare Function GetMapMode Lib "gdi32" (ByVal hDC As Long) As Long

' CHange to allow NULL for PaletteEntry struct.
' Function will Return total number of palette entries
Private Declare Function GetNumSystemPaletteEntries Lib "gdi32" _
Alias "GetSystemPaletteEntries" _
(ByVal hDC As Long, ByVal wStartIndex As Long, _
ByVal wNumEntries As Long, lpPaletteEntries As Long) As Long

Private Declare Function GetSystemPaletteEntries Lib "gdi32" (ByVal hDC As Long, ByVal wStartIndex As Long, ByVal wNumEntries As Long, lpPaletteEntries As PALETTEENTRY) As Long
Private Declare Function CreatePalette Lib "gdi32" (lpLogPalette As LOGPALETTE) As Long
Private Declare Function SetDIBColorTable Lib "gdi32" (ByVal hDC As Long, ByVal un1 As Long, ByVal un2 As Long, pcRGBQuad As RGBQUAD) As Long

Private Declare Function StretchBlt Lib "gdi32" (ByVal hDC As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal nSrcWidth As Long, ByVal nSrcHeight As Long, ByVal dwRop As Long) As Long

'changed lpbits from ByRef as Any
Private Declare Function StretchDIBits Lib "gdi32" _
(ByVal hDC As Long, ByVal x As Long, ByVal y As Long, _
ByVal dx As Long, ByVal dy As Long, ByVal SrcX As Long, _
ByVal SrcY As Long, ByVal wSrcWidth As Long, _
ByVal wSrcHeight As Long, ByVal lpBits As Long, _
lpBitsInfo As BITMAPINFO, ByVal wUsage As Long, _
ByVal dwRop As Long) As Long

Private Declare Function WindowFromDC Lib "user32" (ByVal hDC As Long) As Long
Private Declare Function SetMapMode Lib "gdi32" _
(ByVal hDC As Long, ByVal nMapMode As Long) As Long

'Private Declare Function GetStockObject Lib "gdi32" (ByVal nIndex As Long) As Long
Private Declare Function GetStretchBltMode Lib "gdi32" ()

Private Declare Function GetBoundsRect Lib "gdi32" _
(ByVal hDC As Long, lprcBounds As RECTL, ByVal flags As Long) As Long

Private Declare Function RestoreDC Lib "gdi32" (ByVal hDC As Long, ByVal nSavedDC As Long) As Long

Private Declare Function SaveDC Lib "gdi32" _
(ByVal hDC As Long) As Long

Private Declare Function GdiFlush Lib "gdi32" () As Long

Private Declare Function GetDeviceCaps Lib "gdi32" _
(ByVal hDC As Long, ByVal nIndex As Long) As Long

Private Declare Function SetFocus Lib "user32" (ByVal hwnd As Long) As Long

Private Declare Function GetClientRect Lib "user32" _
(ByVal hwnd As Long, lpRect As RECTL) As Long

Private Declare Function GetWindowRect Lib "user32" _
(ByVal hwnd As Long, lpRect As RECTL) As Long

Private Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)

' Create an Information Context
 Private Declare Function apiCreateIC Lib "gdi32" Alias "CreateICA" _
  (ByVal lpDriverName As String, ByVal lpDeviceName As String, _
  ByVal lpOutput As String, lpInitData As Any) As Long
  
 ' Close an existing Device Context (or information context)
 Private Declare Function apiDeleteDC Lib "gdi32" Alias "DeleteDC" _
  (ByVal hDC As Long) As Long

 Private Declare Function GetSystemMetrics Lib "user32" (ByVal nIndex As Long) As Long
 
Private Declare Function SetBkMode Lib "gdi32" _
(ByVal hDC As Long, ByVal nBkMode As Long) As Long

Private Declare Function apiCreateCompatibleBitmap Lib "gdi32" _
 Alias "CreateCompatibleBitmap" _
 (ByVal hDC As Long, ByVal nWidth As Long, ByVal nHeight As Long) As Long
 
 Private Declare Sub apiCopyMemory Lib "kernel32" Alias "RtlMoveMemory" _
     (Destination As Any, Source As Any, ByVal Length As Long)
 
 Private Declare Function apiGlobalAlloc Lib "kernel32" Alias "GlobalAlloc" _
 (ByVal wFlags As Long, ByVal dwBytes As Long) As Long
 
 Private Declare Function apiGlobalFree Lib "kernel32" Alias "GlobalFree" _
 (ByVal hMem As Long) As Long
 
 Private Declare Function apiGlobalLock Lib "kernel32" Alias "GlobalLock" _
 (ByVal hMem As Long) As Long
 
 Private Declare Function apiGlobalUnlock Lib "kernel32" Alias "GlobalUnlock" _
 (ByVal hMem As Long) As Long
 
 Private Declare Function apiGetStockObject Lib "gdi32" Alias "GetStockObject" _
 (ByVal nIndex As Long) As Long
     
 Private Declare Function apiSelectObject Lib "gdi32" _
  Alias "SelectObject" (ByVal hDC As Long, ByVal hObject As Long) As Long
 
 Private Declare Function apiSetTextAlign Lib "gdi32" Alias "SetTextAlign" _
 (ByVal hDC As Long, ByVal wFlags As Long) As Long
 
 Private Declare Function apiSetTextColor Lib "gdi32" Alias "SetTextColor" _
 (ByVal hDC As Long, ByVal crColor As Long) As Long
 
 Private Declare Function apiSetBkColor Lib "gdi32" Alias "SetBkColor" _
 (ByVal hDC As Long, ByVal crColor As Long) As Long
  
 Private Declare Function apiGetDC Lib "user32" _
   Alias "GetDC" (ByVal hwnd As Long) As Long
 
 Private Declare Function apiReleaseDC Lib "user32" _
   Alias "ReleaseDC" (ByVal hwnd As Long, _
   ByVal hDC As Long) As Long
 
 Private Declare Function apiCreateCompatibleDC Lib "gdi32" _
   Alias "CreateCompatibleDC" (ByVal hDC As Long) As Long
 
  Private Declare Function apiBitBlt Lib "gdi32" _
   Alias "BitBlt" (ByVal hDestDC As Long, ByVal x As Long, ByVal y As Long, _
   ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, _
   ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
 
 Private Declare Function apiDeleteObject Lib "gdi32" _
   Alias "DeleteObject" (ByVal hObject As Long) As Long
 
 Private Declare Function apiGetObject Lib "gdi32" Alias "GetObjectA" _
 (ByVal hObject As Long, ByVal nCount As Long, lpObject As Any) As Long
 
 Private Declare Function apiGetDeviceCaps Lib "gdi32" _
   Alias "GetDeviceCaps" (ByVal hDC As Long, ByVal nIndex As Long) As Long
 
'
Private Declare Function ExtFloodFill Lib "gdi32" _
(ByVal hDC As Long, ByVal x As Long, ByVal y As Long, _
ByVal crColor As Long, ftype As Long) As Long

 Private Declare Function apiMoveToEx Lib "gdi32" Alias "MoveToEx" _
 (ByVal hDC As Long, ByVal x As Long, ByVal y As Long, lpPoint As Any) As Long
 'above was lpPoint as POINTAPI, changed to Any to allow NULL
 
 Private Declare Function apiCreateDIBSection Lib "gdi32" Alias _
 "CreateDIBSection" (ByVal hDC As Long, pBitmapInfo As BITMAPINFO, _
 ByVal un As Long, lplpVoid As Long, ByVal handle As Long, _
 ByVal dw As Long) As Long
 
  Private Declare Function apiCreateDIBSection2 Lib "gdi32" Alias _
 "CreateDIBSection" (ByVal hDC As Long, pBitmapInfo As BITMAPINFO2, _
 ByVal un As Long, lplpVoid As Long, ByVal handle As Long, _
 ByVal dw As Long) As Long
 
  Private Declare Function apiCreateDIBSection255 Lib "gdi32" Alias _
 "CreateDIBSection" (ByVal hDC As Long, pBitmapInfo As BITMAPINFO256, _
 ByVal un As Long, lplpVoid As Long, ByVal handle As Long, _
 ByVal dw As Long) As Long
 
 Private Declare Function apiFillRect Lib "user32" Alias "FillRect" _
 (ByVal hDC As Long, lpRect As RECTL, ByVal hBrush As Long) As Long
 
 Private Declare Function ChooseColor Lib "comdlg32.dll" Alias "ChooseColorA" _
 (pChoosecolor As COLORSTRUC) As Long
 
 Private Declare Function apiCreateSolidBrush Lib "gdi32" Alias "CreateSolidBrush" _
 (ByVal crColor As Long) As Long
 
 Private Declare Function GlobalLock Lib "kernel32" (ByVal hMem As Long) As Long
 Private Declare Function GlobalAlloc Lib "kernel32" _
   (ByVal wFlags As Long, ByVal dwBytes As Long) As Long
 Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" _
 (hpvDest As Any, hpvSource As Any, ByVal cbCopy As Long)
 
Private Declare Function CreateFile Lib "kernel32" _
Alias "CreateFileA" _
(ByVal lpFileName As String, _
ByVal dwDesiredAccess As Long, _
ByVal dwShareMode As Long, _
lpSecurityAttributes As SECURITY_ATTRIBUTES, _
ByVal dwCreationDisposition As Long, _
ByVal dwFlagsAndAttributes As Long, _
ByVal hTemplateFile As Long) As Long

Private Declare Function CloseHandle Lib "kernel32" _
(ByVal hObject As Long) As Long

Private Declare Function WriteFile Lib "kernel32" _
(ByVal hFile As Long, _
lpBuffer As Any, _
ByVal nNumberOfBytesToWrite As Long, _
lpNumberOfBytesWritten As Long, _
ByVal lpOverlapped As Long) As Long
' For asynchronous operation, change to
' lpOverlapped as OVERLAPPED.

Private Declare Function GetDiskFreeSpace Lib "kernel32" _
Alias "GetDiskFreeSpaceA" _
(ByVal lpRootPathName As String, _
lpSectorsPerCluster As Long, lpBytesPerSector As Long, _
lpNumberOfFreeClusters As Long, lpTotalNumberOfClusters As Long) As Long

Private Declare Function ReadFile Lib "kernel32" _
(ByVal hFile As Long, _
lpBuffer As Any, _
ByVal nNumberOfBytesToRead As Long, _
lpNumberOfBytesRead As Long, _
ByVal lpOverlapped As Long) As Long
' For asynchronous operation, change to
' lpOverlapped as OVERLAPPED.

Private Declare Function SetFilePointer Lib "kernel32" _
(ByVal hFile As Long, _
ByVal lDistanceToMove As Long, _
lpDistanceToMoveHigh As Long, _
ByVal dwMoveMethod As Long) As Long

' Constants

' For Color API Chooser
 Private Const CC_SOLIDCOLOR = &H80
 
 ' Constants GDI
 Private Const SM_CXVSCROLL = 2

' File Constants
Private Const MAX_PATH = 260
'Private Const OF_PROMPT = &H2000
'Private Const OF_READ = &H0
'Private Const OF_READWRITE = &H2
'Private Const OF_CREATE = &H1000
Private Const FILE_SHARE_READ = &H1
Private Const FILE_SHARE_WRITE = &H2
Private Const GENERIC_READ = &H80000000
Private Const GENERIC_WRITE = &H40000000
Private Const FILE_FLAG_RANDOM_ACCESS = &H10000000
Private Const FILE_ATTRIBUTE_NORMAL = &H80
Private Const INVALID_HANDLE_VALUE = -1
Private Const CREATE_NEW = 1
Private Const CREATE_ALWAYS = 2
Private Const OPEN_EXISTING = 3
Private Const OPEN_ALWAYS = 4
Private Const TRUNCATE_EXISTING = 5
Private Const FILE_BEGIN = 0
Private Const FILE_CURRENT = 1
Private Const FILE_END = 2

' GetObject constants
Private Const OBJ_DC = 3
Private Const OBJ_METADC = 4
Private Const OBJ_PAL = 5
Private Const OBJ_FONT = 6
Private Const OBJ_BITMAP = 7
Private Const OBJ_REGION = 8
Private Const OBJ_METAFILE = 9
Private Const OBJ_MEMDC = 10
Private Const OBJ_EXTPEN = 11
Private Const OBJ_ENHMETADC = 12
Private Const OBJ_ENHMETAFILE = 13

' constants for the biCompression field
Private Const BI_RGB = 0&
Private Const BI_RLE8 = 1&
Private Const BI_RLE4 = 2&
Private Const BI_bitfields = 3&

' Stock Logical Objects
Private Const WHITE_BRUSH = 0
Private Const LTGRAY_BRUSH = 1
Private Const GRAY_BRUSH = 2
Private Const DKGRAY_BRUSH = 3
Private Const BLACK_BRUSH = 4
Private Const NULL_BRUSH = 5
Private Const HOLLOW_BRUSH = NULL_BRUSH
Private Const WHITE_PEN = 6
Private Const BLACK_PEN = 7
Private Const NULL_PEN = 8
Private Const OEM_FIXED_FONT = 10
Private Const ANSI_FIXED_FONT = 11
Private Const ANSI_VAR_FONT = 12
Private Const SYSTEM_FONT = 13
Private Const DEVICE_DEFAULT_FONT = 14
Private Const DEFAULT_PALETTE = 15
Private Const SYSTEM_FIXED_FONT = 16
Private Const STOCK_LAST = 16

Private Const CLR_INVALID = &HFFFF

' OpenFile() Flags
Private Const OF_READ = &H0
Private Const OF_WRITE = &H1
Private Const OF_READWRITE = &H2
Private Const OF_SHARE_COMPAT = &H0
Private Const OF_SHARE_EXCLUSIVE = &H10
Private Const OF_SHARE_DENY_WRITE = &H20
Private Const OF_SHARE_DENY_READ = &H30
Private Const OF_SHARE_DENY_NONE = &H40
Private Const OF_PARSE = &H100
Private Const OF_DELETE = &H200
Private Const OF_VERIFY = &H400
Private Const OF_CANCEL = &H800
Private Const OF_CREATE = &H1000
Private Const OF_PROMPT = &H2000
Private Const OF_EXIST = &H4000
Private Const OF_REOPEN = &H8000

'  Ternary raster operations
Private Const SRCCOPY = &HCC0020 ' (DWORD) dest = source
Private Const SRCPAINT = &HEE0086        ' (DWORD) dest = source OR dest
Private Const SRCAND = &H8800C6  ' (DWORD) dest = source AND dest
Private Const SRCINVERT = &H660046       ' (DWORD) dest = source XOR dest
Private Const SRCERASE = &H440328        ' (DWORD) dest = source AND (NOT dest )
Private Const NOTSRCCOPY = &H330008      ' (DWORD) dest = (NOT source)
Private Const NOTSRCERASE = &H1100A6     ' (DWORD) dest = (NOT src) AND (NOT dest)
Private Const MERGECOPY = &HC000CA       ' (DWORD) dest = (source AND pattern)
Private Const MERGEPAINT = &HBB0226      ' (DWORD) dest = (NOT source) OR dest
Private Const PATCOPY = &HF00021 ' (DWORD) dest = pattern
Private Const PATPAINT = &HFB0A09        ' (DWORD) dest = DPSnoo
Private Const PATINVERT = &H5A0049       ' (DWORD) dest = pattern XOR dest
Private Const DSTINVERT = &H550009       ' (DWORD) dest = (NOT dest)
Private Const BLACKNESS = &H42 ' (DWORD) dest = BLACK
Private Const WHITENESS = &HFF0062       ' (DWORD) dest = WHITE
Private Const DIB_RGB_COLORS = 0 '  color table in RGBs
  
  ' Background Modes
Private Const TRANSPARENT = 1
Private Const OPAQUE = 2
Private Const BKMODE_LAST = 2

'  Mapping Modes
Private Const MM_TEXT = 1
Private Const MM_LOMETRIC = 2
Private Const MM_HIMETRIC = 3
Private Const MM_LOENGLISH = 4
Private Const MM_HIENGLISH = 5
Private Const MM_TWIPS = 6
Private Const MM_ISOTROPIC = 7
Private Const MM_ANISOTROPIC = 8

' Brush Styles
Private Const BS_SOLID = 0
Private Const BS_NULL = 1
Private Const BS_HOLLOW = BS_NULL
Private Const BS_HATCHED = 2
Private Const BS_PATTERN = 3
Private Const BS_INDEXED = 4
Private Const BS_DIBPATTERN = 5
Private Const BS_DIBPATTERNPT = 6
Private Const BS_PATTERN8X8 = 7
Private Const BS_DIBPATTERN8X8 = 8

'  Device Parameters for GetDeviceCaps()
Private Const DRIVERVERSION = 0      '  Device driver version
Private Const TECHNOLOGY = 2         '  Device classification
Private Const HORZSIZE = 4           '  Horizontal size in millimeters
Private Const VERTSIZE = 6           '  Vertical size in millimeters
Private Const HORZRES = 8            '  Horizontal width in pixels
Private Const VERTRES = 10           '  Vertical width in pixels
Private Const BITSPIXEL = 12         '  Number of bits per pixel
Private Const PLANES = 14            '  Number of planes
Private Const NUMBRUSHES = 16        '  Number of brushes the device has
Private Const NUMPENS = 18           '  Number of pens the device has
Private Const NUMMARKERS = 20        '  Number of markers the device has
Private Const NUMFONTS = 22          '  Number of fonts the device has
Private Const NUMCOLORS = 24         '  Number of colors the device supports
Private Const PDEVICESIZE = 26       '  Size required for device descriptor
Private Const CURVECAPS = 28         '  Curve capabilities
Private Const LINECAPS = 30          '  Line capabilities
Private Const POLYGONALCAPS = 32     '  Polygonal capabilities
Private Const TEXTCAPS = 34          '  Text capabilities
Private Const CLIPCAPS = 36          '  Clipping capabilities
Private Const RASTERCAPS = 38        '  Bitblt capabilities
Private Const ASPECTX = 40           '  Length of the X leg
Private Const ASPECTY = 42           '  Length of the Y leg
Private Const ASPECTXY = 44          '  Length of the hypotenuse

Private Const LOGPIXELSX = 88        '  Logical pixels/inch in X
Private Const LOGPIXELSY = 90        '  Logical pixels/inch in Y

Private Const SIZEPALETTE = 104      '  Number of entries in physical palette
Private Const NUMRESERVED = 106      '  Number of reserved entries in palette
Private Const COLORRES = 108         '  Actual color resolution

' StretchBlt() Modes
Private Const BLACKONWHITE = 1
Private Const WHITEONBLACK = 2
Private Const COLORONCOLOR = 3
Private Const HALFTONE = 4
Private Const MAXSTRETCHBLTMODE = 4

Private Const TWIPSPERINCH = 1440

' ExtFloodFill style flags
Private Const FLOODFILLBORDER = 0
Private Const FLOODFILLSURFACE = 1

' ** START OF OUR VARIABLES **

' Handle to our DIB Section
Dim hBMap As Long

' Screen Compatible DCs
Dim hDC As Long
Dim hdc1 As Long

' Not need for this version
' Was for versions using DIB
' Leave in case we want File Save
Dim bmh256 As BITMAPINFO256

Dim pal256(0 To 255) As PALETTEENTRY
' handle to System generated Halftone palette
Dim hpalHalfTone As Long

' hold handle to original bitmap selected into a DC
Dim hBmpOrig As Long

' Array holds starting Byte offset for begining of each Gif Frame
Private mGifStart() As Long
' Array holds starting Byte offset for begining of each Gif Frame
Private mGifEnd() As Long


' *********** CHANGE*********
' Change to as Object before release
' as it is the only DLL Reference
' in this module.
' Array of StdPicture objects
Dim hStdPicture() As Object 'StdPicture

' Handle to Access Application Device Context
Dim hDCApp As Long

' Saves declaring it in every function/sub
Private lngRet As Long
Private blRet As Boolean
Private lngTemp As Long
Dim hDCtemp As Long
Dim bTemp As Byte
Dim x As Integer

'Assorted GDI handles
Private mImageCtl As Object
Private mhDCImage As Long
Private mBitmap As Long
Private mBitMapAdd As Long
Private hOrigBitmap As Long
Private hOrigFont As Long
Private hBrush As Long
Private hOldBrush As Long
Private hOrigBrush As Long
Dim mForeColor As Long
Dim mBackColor As Long


' Need some GDI structures
Private lpBmih As BITMAPINFO
Dim rc As RECTL
Dim bm As BITMAP
Dim bmap As BITMAP
 
' Byte array to hold entire Original Animated Disk file.
Dim bArray() As Byte

' Logical Screen Descriptor packed bits field
' since we will also use this variable in
' our processing for each Gif fram.
' Don't really need to store this field for
' each frame but good idea for debugging
' and in case this field is extended or
' used for additional purposes.
Dim PackedFields() As Byte

' Logical Screen Descriptor
' Background color Index
Dim BackgroundColorIndex As Byte

' Logical Screen Descriptor
' Pixel Aspect Ratio
Dim PixelASpectRatio As Byte

' Logical Screen Descriptor
' number of bits per primary color in orig pic
Dim ColorResolution As Byte

' Logical Screen Descriptor
' Is there a Global Color Table immediately
' following this Block
Dim GlobalColorTableFlag As Boolean

' Max 256 Colors of 8bitx3 RGB triplets values
Dim GlobalColorTable(0 To 767) As Byte

' Logical Screen Descriptor
' Image Max Width
Dim LogWidth As Integer

' Logical Screen Descriptor
' Image Max Height
Dim LogHeight As Integer

' Logical Screen Descriptor
' Is Global Color table Sorted?
Dim GSortFlag As Boolean

' Logical Screen Descriptor
' raise 2 to the (value of this field + 1)
' to get actaul size of Global Color Table
Dim SizeOfGlobalColorTable As Byte

' Arrays to store the value for each
' individual frame of the Animated Gif.
Private Const SizeOfMaxLocalColorTable = 768

Dim ImageLeft() As Integer
Dim ImageTop() As Integer
Dim ImageWidth() As Integer
Dim ImageHeight() As Integer
Dim LSortFlag() As Boolean
Dim LocalColorTableFlag() As Boolean
Dim InterLaceFlag() As Boolean
Dim SizeOfLocalColorTable() As Byte
Dim LocalColorTable(0 To 767) As Byte
Dim LZWMinimumCodeSize() As Byte
Dim DelayTime() As Integer
Dim TransparentColorIndex() As Byte
Dim DisposalMethod() As Byte
Dim UserInputFlag() As Boolean
Dim TransparentColorFlag() As Boolean

' ********* FIX !!!!!!!!!!!!!!!!   *****************************
' Will come back and add more support for
' LocalColorTables
'Dim arrayLocalColorTables() As LocalColorTable()

' Loop counter
Dim ctr As Long

' Holder for temp RGB values
Dim bTemparray(0 To 2) As Byte

' Another Holder for temp BackGround RGB Value
Dim bBGarray(0 To 2) As Byte

' Another Holder for temp Transparent RGB Value comparison
Dim bTransparentarray(0 To 2) As Byte

' ***** SHOULD BE A PROPERTY!! *******
Dim strGifFileName As String

' FOr createDibSection
Dim bmh As BITMAPINFO256

' User Defined Delay Property
Dim mUserDelay As Long

' Prop to Signal Stop Rendering
Dim mStopRender As Boolean



'DEVELOPED AND TESTED UNDER MICROSOFT VB6 ONLY
'
'Copyright: Stephen Lebans - Lebans Holdings 1999 Ltd.
'
'
'Name:      Class clsGif24bits
'
'Version:   2.0
'
'Purpose:   Allow for display of Animated Gif files
'           in a standard Picture Control.
'           No external ActiveX controls or DLL's required.
'
'
'Author:    Stephen Lebans
'Email:     Stephen@lebans.com
'Web Site:  www.lebans.com
'Date:      May 07, 2000, 2:01:25 AM
'
'Called by: Wherever. :-)
'
'Calls:     Bunch of API stuff
'
'Inputs:    See inline Comments for explanation

'Output:    See inline Docs for each Function call
'
'Credits:   Dev Ashish, Terry Kreft, the MS KB
'           and others mentioned directly
'           in the code comments. :-)
'
'BUGS:      No serious ones that I've noticed but something always pops up.
'           Please report any bugs to my email address.
'
'What's Missing:
'           The actual Gif Render function needs to run in its own
'           seperate thread. Not really possible in this version of VB.
'           I'm going to stick it all in a VB6 ActiveX control.
'
'           Please send me a copy of any enhancements/bug fixes you create for this
'           function at Stephen@lebans.com
'
'Enjoy
'Stephen Lebans
'********************************************
'***************** CODE START ***************



Property Get UserDelay() As Long
UserDelay = mUserDelay
End Property

Property Let UserDelay(lngDelay As Long)
If IsNumeric(lngDelay) Then
  'If lngDelay < 1 Then mUserDelay = 10
 
  'If lngDelay > 1000 Then mUserDelay = 1000
   mUserDelay = lngDelay 'mUserDelay + lngDelay
Else
mUserDelay = 10 'mUserDelay + lngDelay
End If
If mUserDelay > 1000 Then mUserDelay = 1000
If mUserDelay < 1 Then mUserDelay = 1
End Property

Property Get StopRender() As Boolean
StopRender = mStopRender
End Property

Property Let StopRender(blS As Boolean)
If blS Then
    mStopRender = True
Else
    mStopRender = False
End If
End Property


' Function to Convert Twips to Pixels
' Used in Access
Private Function GetTwipsPerPixel() As Integer

    ' Determine how many Twips make up 1 Pixel
    ' based on current screen resolution
    
    Dim lngIC As Long
    lngIC = apiCreateIC("DISPLAY", vbNullString, _
     vbNullString, vbNullString)
    
    ' If the call to CreateIC didn't fail, then get the info.
    If lngIC > 0 Then
        GetTwipsPerPixel = GetDeviceCaps(lngIC, LOGPIXELSX)
        ' Release the information context.
        apiDeleteDC lngIC
    Else
        ' Something has gone wrong. Assume a standard value.
        GetTwipsPerPixel = 120
    End If
 End Function

 
Public Property Set ImageCtl(CurImageCtl As Object)
Set mImageCtl = CurImageCtl
End Property

Public Property Get hDCImage()
' Let's check and see if there is a valid Image Control
' in our Class Image Property
If hDC = 0 Then
hDC = hDC
End If
hDCImage = hDC
End Property

   
Public Sub Update(ctl As Image)
' Update the Image Control display
' We do this by simply copying the mBitmapAdd's contents to
' the control's PictureData prop

' We need to copy over the following data to our
' temporary array of bytes. We're creating a Packed DIB.
' 1. Bitmapinfo struct including ColorTable
' 2. Actual Bits of the bitmap
'
' Our Byte array
Dim arrTemp() As Byte

' DibSection structure
Dim ds As DIBSECTION

' Array of RGB quads to hold Dib's ColorTable
Dim quad(0 To 256) As RGBQUAD

' Fill the array with the ColorTable
' Remember we leave this DIB selected into this
' specific Device Context until Class terminate
' or we create a New DIB because user loads a new Gif.
lngRet = GetDIBColorTable(hDC, 0, 256, quad(0))

lngRet = apiGetObject(hBMap, Len(ds), ds)

' Redimdension our byte array to hold the packed DIB
ReDim arrTemp(ds.dsBmih.biSizeImage + Len(bmh256))


' Copy the BitmapInfoHeader
apiCopyMemory arrTemp(0), ds.dsBmih, Len(ds.dsBmih)

' Copy the ColorTable. ALways 256 RGB QUADS
' DOn't understand why compiler doesn't like:
' Len(bmh256.bmiColors) instead of "256 * 4"
'apiCopyMemory arrTemp(Len(ds.dsBmih)), quad(0), 256 * 4 'Len(bmh256.bmiColors)

' Copy the actual Bitmap Bits
apiCopyMemory arrTemp(Len(ds.dsBmih)), ByVal ds.dsBm.bmBits, ds.dsBmih.biSizeImage

' Copy data back to Image Control's PictureData property
' Display is updated by accessing the prop.
' No manual forcing of screen redraw is required.
'ctl.PictureData = arrTemp

End Sub


Public Sub ClearControl()
Dim rc1 As RECTL
Dim hNewBrush As Long
'If hDC > 0 Then
'   lngRet = apiBitBlt(hDC, 0&, 0&, lpBmih.bmiHeader.biWidth, _
'  lpBmih.bmiHeader.biHeight, hDC, 0, 0, WHITENESS)

' Let's use mBackColor
'lngRet = apiFloodFill(hDC, 0, 0, mBackColor)

If hDC < 1 Then Exit Sub
rc1.Right = bmh256.bmiHeader.biWidth
rc1.Bottom = bmh256.bmiHeader.biHeight

lngTemp = ConvertSystemColor(mImageCtl.BackColor)
hNewBrush = apiCreateSolidBrush(lngTemp)
'holdbrush = apiSelectObject(hDC, hnewbrush)
'lngRet = apiDeleteObject(holdbrush)

lngRet = apiFillRect(hDC, rc1, hNewBrush)
lngRet = apiDeleteObject(hNewBrush)

Update mImageCtl

End Sub


Public Sub SetForeColor()
Dim lngTemp As Long
Dim x As Long, CS As COLORSTRUC, CustColor(16) As Long
Dim hnewpen As Long, holdpen As Long
CS.lStructSize = Len(CS)
CS.hwnd = mImageCtl.Application.hWndAccessApp
CS.flags = CC_SOLIDCOLOR
CS.lpCustColors = String$(16 * 4, 0)
x = ChooseColor(CS)
If x = 0 Then
'Error need handler here
'mForeColor = 0
Else
lngTemp = mForeColor
mForeColor = CS.rgbResult
End If

' need error checking here
' Ask user if they really want to set
' ForeColor and BackColor to the same value
If mForeColor = mBackColor Then
lngRet = MsgBox("Do you really want to set" & vbCrLf & _
       "Backcolor and ForeColor to the same Value!", vbYesNo, _
       "WARNING:BackColor and ForeColor are the same Value!")
If lngRet = vbNo Then

mForeColor = lngTemp
Exit Sub
End If
End If

End Sub



Public Sub SetBackColor()
Dim lngTemp As Long
Dim x As Long, CS As COLORSTRUC, CustColor(16) As Long
Dim hnewpen As Long, holdpen As Long
CS.lStructSize = Len(CS)
CS.hwnd = mImageCtl.Parent.hwnd  'mImageCtl.Application.hWndAccessApp
CS.flags = CC_SOLIDCOLOR
CS.lpCustColors = String$(16 * 4, 0)
x = ChooseColor(CS)
If x = 0 Then
'Error need handler here
'mBackColor = RGB(255, 255, 255)
Else
lngTemp = mBackColor
mBackColor = CS.rgbResult

End If


' need error checking here
' Ask user if they really want to set
' ForeColor and BackColor to the same value
If mForeColor = mBackColor Then
lngRet = MsgBox("Do you really want to set" & vbCrLf & _
       "Backcolor and ForeColor to the same Value!", vbYesNo, _
       "WARNING:BackColor and ForeColor are the same Value!")
If lngRet = vbNo Then
    mBackColor = lngTemp
    Exit Sub
End If
End If
mImageCtl.BackColor = mBackColor
'lngRet = apiSetBkColor(hDC, mBackColor)
End Sub
             
             
' Function is Self explanatory<bg>
Private Function GetUniqueFilename(Optional Path As String = "", _
Optional Prefix As String = "", _
Optional UseExtension As String = "") _
As String

' originally Posted by Terry Kreft
' to: comp.Databases.ms -Access
' Subject:  Re: Creating Unique filename ??? (Dev code)
' Date: 01/15/2000
' Author: Terry Kreft <terry.kreft@mps.co.uk>

' SL Note: Input strings must be NULL terminated.
' Here it is done by the calling function.

  Dim wUnique As Long
  Dim lpTempFileName As String
  Dim lngRet As Long
   Dim FileHeader As BITMAPFILEHEADER
  wUnique = 0
  If Path = "" Then Path = CurDir
  lpTempFileName = String(MAX_PATH, 0)
  lngRet = GetTempFileName(Path, Prefix, _
                            wUnique, lpTempFileName)
 
  lpTempFileName = Left(lpTempFileName, _
                        InStr(lpTempFileName, Chr(0)) - 1)
  Call Kill(lpTempFileName)
  If Len(UseExtension) > 0 Then
    lpTempFileName = Left(lpTempFileName, Len(lpTempFileName) - 3) & UseExtension
  End If
  GetUniqueFilename = lpTempFileName
End Function

' **Not used in this version
' **Required for Access version
Public Function fCreateDib() As Boolean
    
' Standardize on 8 bit DibSection. Gif's are MAX 8 bits.
' Gifs are generally quite small. Since for our purposes CreateDibSection
' only supports 1,4 or 8 bits we'll take the easy road and
' go 8 bit all of the time.

' Init the Dib's ColorTable

' **** FIX TO SUPPORT MULTIPLE LOCAL COLORTABLE's !!!!!****************

' blRet = fCreatePal256(True)
'sMakeOfficePal256
'sMakeWebSafePalette

'sGrabPalette

bmh256.bmiHeader.biBitCount = 24 '8 'bm.bmBitsPixel
bmh256.bmiHeader.biHeight = LogHeight  '4 'bm.bmHeight
bmh256.bmiHeader.biPlanes = 1 'bm.bmPlanes
bmh256.bmiHeader.biWidth = ((LogWidth + 31) And &HFFFFFE0) '/ 4
bmh256.bmiHeader.biSize = Len(bmh256.bmiHeader)
bmh256.bmiHeader.biCompression = BI_RGB
bmh256.bmiHeader.biSizeImage = 0 '(bmh.bmiHeader.biWidth) * bmh.bmiHeader.biHeight  ' + Len(bmh)
hBMap = apiCreateDIBSection255(0&, bmh256, DIB_RGB_COLORS, mBitMapAdd, 0&, 0&)
DoEvents

' THis is deleted when Class exits
hBmpOrig = apiSelectObject(hDC, hBMap)


 Dim hBrush As Long, origBrush As Long
'hBrush = GetStockObject(WHITE_BRUSH)
'origBrush = apiSelectObject(hDC, hBrush)
'lngRet = ExtFloodFill(hDC, 230, 230, RGB(255, 255, 255), FLOODFILLBORDER)
rc.Top = 0 'lngPrtTopNoPrint
rc.Bottom = bmh256.bmiHeader.biHeight '((lngResY * 11) - lngPrtTopNoPrint) '/ 4
rc.Left = 0 'lngPrtLeftNoPrint '0
rc.Right = bmh256.bmiHeader.biWidth '((lngResX * 8.5) - lngPrtLeftNoPrint)
'   lngRet = FillRect(hDC, rc, hBrush)
'lngRet = apiSelectObject(hDC, origBrush)

lngTemp = ConvertSystemColor(mImageCtl.BackColor)
hBrush = apiCreateSolidBrush(lngTemp)
'holdbrush = apiSelectObject(hDC, hnewbrush)
'lngRet = apiDeleteObject(holdbrush)

lngRet = apiFillRect(hDC, rc, hBrush)
lngRet = apiDeleteObject(hBrush)


End Function


' ***************
' Function to create a Temp Bitmap
' to select into our double buffer DC logic
Public Function fCreateBitMap() As Boolean
 
' Temp handles for GDI objects
Dim hBrush As Long, origBrush As Long

' Fill in our Bitmap structure
bmap.bmBitsPixel = 24
bmap.bmHeight = LogHeight
bmap.bmPlanes = 1
bmap.bmWidth = ((LogWidth + 31) And &HFFFFFE0) '/ 4
bmap.bmWidthBytes = bmap.bmWidth * 3
hBMap = CreateCompatibleBitmap(hDC, bmap.bmWidth, bmap.bmHeight)

' THis is deleted when Class exits
hBmpOrig = apiSelectObject(hdc1, hBMap)

' Fill in our Rectabgle structure
rc.Top = 0
rc.Bottom = bmap.bmHeight
rc.Left = 0
rc.Right = bmap.bmWidth

' Let's fill our new Bitmap with the Background Color
' Make sure we can handle System colors(MSB is set)
lngTemp = ConvertSystemColor(mImageCtl.BackColor)
hBrush = apiCreateSolidBrush(lngTemp)
lngRet = apiFillRect(hdc1, rc, hBrush)
lngRet = apiDeleteObject(hBrush)

End Function


' **************
Private Sub Class_Initialize()
hBMap = 0

' Device Context For CreateBitmap
' This is released in Class_Terminate
hdc1 = apiCreateCompatibleDC(0&) 'hDCApp)

' DC we will actually use on Screen
hDC = Form1.Picture1.hDC

End Sub

' These functions were required in the 8Bit verion
' for Microsoft Access.
' *****************
Private Function fCreatePal256(blGlobalorLocal, Optional lngIndex As Long = -1) As Boolean
  
 Dim quad(0 To 255) As RGBQUAD
Dim quad1(0 To 255) As RGBQUAD
'lngRet = GetDIBColorTable(hDC, 0, 256, quad(0))
'lngRet = GetPaletteEntries(hOrigPal, 1, 255, pal256(0))
'lngRet = GetDIBColorTable(hDC, 1, 256, quad(0))

'lngRet = SetDIBColorTable(hDC, lngOleBackColor, 1, quadWhite(0))
Dim x As Long, y As Long

' Init secondary loop index
y = 0
If blGlobalorLocal Then
' use Global Color Table
For x = 0 To 255
quad(x).RGBBlue = GlobalColorTable(y)
quad(x).RGBGreen = GlobalColorTable(y + 1)
quad(x).RGBRed = GlobalColorTable(y + 2)

' Fill in our BitmapInfo. Declared in General Declarations
'bmh256.bmiColors(x).rgbBlue = GlobalColorTable(y)
'bmh256.bmiColors(x).rgbGreen = GlobalColorTable(y + 1)
'bmh256.bmiColors(x).rgbRed = GlobalColorTable(y + 2)
'bmh256.bmiColors(x).rgbReserved = 0

y = y + 3
Next x

Else
' Use Local Color Table, use optional index
If lngIndex <> -1 Then
' Copy from our Array of LocalColorTabels into this
' temp LocalColorTable array
'For x = 0 To UBound(LocalColorTable) - 1
'arrayLocalColorTables (lngIndex)
For x = 0 To 255
quad(x).RGBBlue = LocalColorTable(y)
quad(x).RGBGreen = LocalColorTable(y + 1)
quad(x).RGBRed = LocalColorTable(y + 2)
y = y + 3
Next x
End If
End If

lngRet = SetDIBColorTable(hDC, 1, 256, quad(0))
lngRet = GetDIBColorTable(hDC, 1, 256, quad1(0))
'If LocalColorTableFlag(lc) Then
' apiCopyMemory bTransparentarray(0), LocalColorTable(TransparentColorIndex(lc) * 3), 3
' For x = 0 To (3 * (2 ^ (SizeOfLocalColorTable(lc) + 1))) - 3 Step 3
' apiCopyMemory bTemparray(0), LocalColorTable(x), 3
'
End Function


' Function to save the contents of a DIBSection to
' a disk Bitmap file
' Will add this as a method for this class next release.
Public Function fSaveFile() As Boolean
' For System Temp Folder
' and temp unique filename
Const Pathlen = 255

Dim strPath  As String * Pathlen
Dim strFixed  As String * Pathlen
Dim strPathandFileName  As String
Dim FileHeader As BITMAPFILEHEADER
Dim Fnum As Integer
Dim hFile As Long

Dim quad(255) As RGBQUAD

lngRet = GetDIBColorTable(hDC, 0, 256, quad(0))

' Get the Systems Temp path
' Returns Length of path(num characters in path)
lngRet = GetTempPath(Pathlen, strPath)
' Chop off NULLS and trailing "\"
strPath = Left(strPath, lngRet) & Chr(0)

' Now need a unique Filename
' locked from a previous aborted attemp.
strPathandFileName = GetUniqueFilename(strPath, "SLC" & Chr(0), "BMP")

Dim sec As SECURITY_ATTRIBUTES
 Dim lngBytesWritten As Long
sec.bInheritHandle = True
sec.lpSecurityDescriptor = 0
sec.nLength = Len(sec)
    
hFile = CreateFile(strPathandFileName, GENERIC_WRITE, 0&, sec, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0)
 
 Dim ds As DIBSECTION
 lngRet = apiGetObject(hBMap, Len(ds), ds)
 Dim x As Long, y As Long, z As Long, BperS As Long
 lngRet = GetDiskFreeSpace("C:\", x, BperS, x, z)
 
 ' Save the Bitmap to a disk file
'With FileHeader
  '.bfType = &H4D42
 ' .bfSize = Len(FileHeader) + Len(MyBitmapInfo) + MyBitmapInfo.bmiHeader.biSize
  '.bfOffBits = Len(FileHeader) + Len(MyBitmapInfo)
'End With

With FileHeader
  .bfType = CInt(&H4D42)
  x = Len(FileHeader) + Len(ds.dsBmih) + ds.dsBmih.biSizeImage + 1024
  '.bfSize = Len(FileHeader) + Len(ds.dsBmih) + ds.dsBmih.biSizeImage
   apiCopyMemory FileHeader.bfSize(0), x, 4
  '.bfOffBits = Len(ds.dsBmih) + 8 '+ 14 '(MyBitmapInfo)
  x = Len(ds.dsBmih) + 1024  '+ 14 '(MyBitmapInfo)
  apiCopyMemory FileHeader.bfOffBits(0), x, 4
End With
 
 
 ' ByVal required if WriteBuffer is a string
 lngRet = WriteFile(hFile, FileHeader, Len(FileHeader), lngBytesWritten, 0)
 ' ByVal required if WriteBuffer is a string
 lngRet = WriteFile(hFile, ds.dsBmih, Len(ds.dsBmih), lngBytesWritten, 0)
lngRet = WriteFile(hFile, quad(0), 1024, lngBytesWritten, 0)


' Dim x As Long
z = 0
 x = ds.dsBmih.biSizeImage / BperS
'For y = 1 To x 'Step BperS
lngRet = WriteFile(hFile, ByVal ds.dsBm.bmBits, ds.dsBmih.biSizeImage, lngBytesWritten, 0)
'z = z + BperS
'Next
'lngRet = WriteFile(hFile, mBitMapAdd + z, BperS, lngBytesWritten, 0)
CloseHandle (hFile)
End Function
 

' Function to Read file - used in Next revision
Private Sub MyReadFile(NewFile As String)
Dim sec As SECURITY_ATTRIBUTES
Dim h1 As Long
Dim ReadBuffer As String
Dim BytesRead As Long
Dim rc As Long

sec.bInheritHandle = True
sec.lpSecurityDescriptor = 0
sec.nLength = Len(sec)

h1 = CreateFile(NewFile, GENERIC_READ, 0, sec, OPEN_ALWAYS, _
FILE_ATTRIBUTE_NORMAL, 0)

ReadBuffer = String(1024, vbNullChar)

' ByVal required if ReadBuffer is a string
rc = ReadFile(h1, ByVal ReadBuffer, Len(ReadBuffer), BytesRead, 0)

ReadBuffer = Left(ReadBuffer, BytesRead)
CloseHandle (h1)

'Debug.Print "ReadFile Result:"
'Debug.Print ReadBuffer
End Sub
 

Private Sub Class_Terminate()
Dim x As Long
' Release our Application DC
'lngRet = apiReleaseDC(Application.hWndAccessApp, hDCApp)

' Reset handles to StdPic objects
'For x = 0 To UBound(hStdPicture) - 1
'Set hStdPicture(x) = Nothing
'Next
On Error Resume Next
Dim varTemp As Long
varTemp = hStdPicture(0)
If varTemp > 1 Then
For x = 0 To UBound(hStdPicture) '- 1
Set hStdPicture(x) = Nothing
Next
End If

' Delete out any DC's created
' when this class was initialized.
' Select out new Bitmap and select
' in original Bitmap.

hBMap = apiSelectObject(hdc1, hBmpOrig)
lngRet = apiDeleteDC(hdc1)
lngRet = apiDeleteObject(hBMap)

' Let go of PictureBox object
Set mImageCtl = Nothing

End Sub


' This is the main function. Missing final
' support for Local Color Tables. Will
' be included with next revision.
Public Function fGifBreakOutFrames() As Boolean
 ' Break an Animated Gif file up into the seperate GIF frames
 ' that make up the entire animation.
 
  Const Pathlen = 256
 
 ' GIF Block Extension Label Values
 Const ExtensionIntroducer = &H21
 Const ApplicationExtension = &HFF
 Const CommentExtension = &HFE
 Const GraphicControlExtension = &HF9
 Const ImageDescriptor = &H2C
 Const PlainTextExtension = &H1
 Const Trailer = &H3B
 ' Intel Byte ordering
 Const GIF89 = &H38464947
 
 ' Length of Logical Screen Descriptor Block
 Const lenLogicalScreenDescriptor = 7
 
 ' Length of Graphic Control Extension Block
 Const lenGraphicControlExtension = 7
 
 ' Length of Image Descriptor Block
 Const lenImageDescriptor = 10
  
 ' Generally use Hex values but
 ' Decimal is clearer for educational purposes.
 Const Bit8 = 128
 Const Bit7 = 64
 Const Bit6 = 32
 Const Bit5 = 16
 Const Bit4 = 8
 Const Bit3 = 4
 Const Bit2 = 2
 Const Bit1 = 1
 
' Length of Gif File Header
 Const lenGifHeader = 6
 
 ' Temp var to  check our Constants against
 Dim varTemp As Variant

' Need Flag so we can init arrays properly
' first time through loops
Dim blFirstTime As Boolean
blFirstTime = True

' Saves typing and necessary logic to
' init and Redim our storage arrays
' Loop Counter
Dim lc As Long

Dim strPath  As String * Pathlen
Dim strPathandFileName  As String

 Dim lngStartLocalColorTable As Long
Dim lngStartGlobalColorTable As Long
Dim lngNewTransparent As Long
Dim lngIndexDuplicate As Long
Dim lngMax As Long
Dim lngMaxPrevious As Long

 Dim Fnum As Integer
 ' Length of file
 Dim FLength As Long
 
 
' Initialize our Class arrays
' Most importantly we release all of our handles
' to the StdPicture objects that were created the
' last time we ran this function.
CleanUp
 
 ' Get next avail file handle
 Fnum = FreeFile
        
       If Len(strGifFileName & vbNullString) < 1 Then
       MsgBox "Please select an Animated Gif File!"
       Call SGetGifFileName
       End If
       
       ' If user selected Cancel then exit
      If Len(strGifFileName & vbNullString) < 1 Then Exit Function
       
    Open strGifFileName For Binary As Fnum
    FLength = LOF(Fnum)
    ' Animated Gifs are relatively Small
    ' Read in Entire File!
    ReDim bArray(1 To FLength)
    Get Fnum, , bArray
    Close Fnum
        
    ' Current Position in our Byte Array
    Dim lngCurPosition As Long
    
    ' Starting offset to  current GIF frame
    Dim lngGifStart As Long
    
    ' Ending offset to current GIF Frame
    Dim lngGifEnd As Long
    
    
    
    ' We need to handle the PackedFlags array seperately
    ' since it is the only array used in this part of the function
    ReDim PackedFields(0)
    
    ' Let's check and make sure we are an Animated Gif!
    apiCopyMemory lngRet, bArray(1), 4 ' was 5 FIX THIS
    If lngRet <> GIF89 Then GoTo err_NoGif
       
    ' OK let's fill in our variables we derive from
    ' The Logical Screen Descriptor Block that always follows
    ' the 6 byte File Header with the GIF Signature
    apiCopyMemory LogWidth, bArray(lenGifHeader + 1), 2
    apiCopyMemory LogHeight, bArray(lenGifHeader + 3), 2
    apiCopyMemory PackedFields(0), bArray(lenGifHeader + 5), 1
    apiCopyMemory BackgroundColorIndex, bArray(lenGifHeader + 6), 1
    apiCopyMemory PixelASpectRatio, bArray(lenGifHeader + 7), 1
    
    
    ' update our current position in the buffer
    lngCurPosition = lngCurPosition + lenGifHeader + lenLogicalScreenDescriptor
    
       
    ' Let's derive our props from the packed Bit fields
    If PackedFields(0) And Bit8 Then GlobalColorTableFlag = True
    ' ColorResolution variable is a Byte with really only 3 bits significant
    If PackedFields(0) And Bit7 Then ColorResolution = Bit3
    If PackedFields(0) And Bit6 Then ColorResolution = ColorResolution Or Bit2
    If PackedFields(0) And Bit5 Then ColorResolution = ColorResolution Or Bit1
    
    If PackedFields(0) And Bit4 Then GSortFlag = True
    
    ' SizeOfGlobalColorTable variable is a Byte with really only 3 bits significant
    ' SizeOfGlobalColorTable variable is a Byte with really only 3 bits significant
    ' clear out first in case Bit 3 is still set from last time!!!!!!!!!
    ' Geeze this logic took me 2 hours to figure out. :-(
    SizeOfGlobalColorTable = 0
    If PackedFields(0) And Bit3 Then SizeOfGlobalColorTable = Bit3
    If PackedFields(0) And Bit2 Then SizeOfGlobalColorTable = SizeOfGlobalColorTable Or Bit2
    If PackedFields(0) And Bit1 Then SizeOfGlobalColorTable = SizeOfGlobalColorTable Or Bit1
    
    ' is there a Global Color Table?
    If GlobalColorTableFlag Then
        ' Calculate size of Global Color Table
        ' to calculate offset to jump to start of next Block
        ' Color Table = RGB Triple,  3 bytes per entry
        ' Copy the Color Table to its storage array
        ' Just changed line below to fix problem of starting
        ' to copy color table 2 bytes to soon
        ' 1 byte was index on array other is lngcurposition
        apiCopyMemory GlobalColorTable(0), bArray(lngCurPosition + 1), (3 * (2 ^ (SizeOfGlobalColorTable + 1)))
         lngStartGlobalColorTable = lngCurPosition + 1
        lngCurPosition = lngCurPosition + (3 * (2 ^ (SizeOfGlobalColorTable + 1)))
    End If
    
    
    ' Reset starting point for this Gif
    ' update our current position in the buffer
    lngCurPosition = lngCurPosition + 1
    ' Every temp Gif will have File header above and
    ' Global Color Table if it exists
    lngGifStart = lngCurPosition
    
' Check to make sure we are not at the end of the file
    'If bArray(lngCurPosition) <> Trailer Then
     '   If lngCurPosition < FLength Then

'Initialize Loop counter for first time through
lc = 0
' Clear out our array of Standard Picture handles
 Erase hStdPicture()

Do While lngCurPosition <= FLength
' Now are building the guts for each indiviual Gif frame
' of the Animated Gif file.
' Let's Redim our storage arrays


        ReDim Preserve PackedFields(lc)
        ReDim Preserve ImageLeft(lc)
        ReDim Preserve ImageTop(lc)
        ReDim Preserve ImageWidth(lc)
        ReDim Preserve ImageHeight(lc)
        ReDim Preserve LSortFlag(lc)
        ReDim Preserve LocalColorTableFlag(lc)
        ReDim Preserve InterLaceFlag(lc)
        ReDim Preserve SizeOfLocalColorTable(lc)
        
        ReDim Preserve LZWMinimumCodeSize(lc)
        ReDim Preserve DelayTime(lc)
        ReDim Preserve TransparentColorIndex(lc)
        ReDim Preserve DisposalMethod(lc)
        ReDim Preserve UserInputFlag(lc)
        ReDim Preserve TransparentColorFlag(lc)
        
        'ReDim Preserve arrayLocalColorTables(lc)

    ' Let's see what the next Block is.
    ' We'll keep moving forward until we hit the
    ' Image Descriptor Block.
    ' Immediately following this Block is the actual
    ' Image data. We will copy from the start of the Gif until the
    ' end of the Image Data to a temporary Disk file.
    ' We will then load this temp GIF file(frame) into an Image Control.
    
    Do While bArray(lngCurPosition) <> ImageDescriptor
    
        ' Usually we find next an Image Descriptor or the Netscape Application Extension Block
        ' Let's check for all Blocks that have are proceeded
        ' by the ExtensionInducer value
        If bArray(lngCurPosition) = ExtensionIntroducer Then
    
        Select Case bArray(lngCurPosition + 1)
        
        Case ApplicationExtension
        ' This needs to check and see if it is
        ' the Netscape App Ext to read the value
        ' for the number of itinerations the loop
        ' should be executed to display the GIF
        
        ' Jump to start of Application Data Sub Blocks
        lngCurPosition = lngCurPosition + 14 'bArray(lngCurPosition + 14)
       lngCurPosition = lngCurPosition + bArray(lngCurPosition)
        
       ' if Next byte is 0 then this is the Block terminator
        'If bArray(lngCurPosition + 1) <> 0 Then
        ' Keep reading Comment Blocks until done
        Do While bArray(lngCurPosition + 1) <> 0
            lngCurPosition = lngCurPosition + bArray(lngCurPosition + 1)
        Loop
         lngCurPosition = lngCurPosition + 1
        
        Case CommentExtension
        ' Jump length of first Comment Data Sub Block
        ' First Byte of this Data block is always the Size
        ' not including this Byte!
        lngCurPosition = lngCurPosition + 2
        lngCurPosition = lngCurPosition + bArray(lngCurPosition)
        ' if Next byte is 0 then this is the Block terminator
        'If bArray(lngCurPosition + 1) <> 0 Then
        ' Keep reading Comment Blocks until done
        Do While bArray(lngCurPosition + 1) <> 0
            lngCurPosition = lngCurPosition + bArray(lngCurPosition + 1)
        Loop
        'End If
         lngCurPosition = lngCurPosition + 1
       
' **** ERROR
' ** Sharing PackedFields with GraphicControl and ImageDescriptor
' No harm done becasue I store the derived vars from Packed fields individually.
        Case GraphicControlExtension
         ' Here we can derive key props concerning the
         ' playback of the GIF.
         ' OK let's fill in our variables we derive from this block
        apiCopyMemory PackedFields(lc), bArray(lngCurPosition + 2 + 1), 1
        apiCopyMemory DelayTime(lc), bArray(lngCurPosition + 2 + 2), 2
        apiCopyMemory TransparentColorIndex(lc), bArray(lngCurPosition + 2 + 4), 1
    
        ' SizeOfGlobalColorTable variable is a Byte with really only 3 bits significant
        If PackedFields(lc) And Bit5 Then DisposalMethod(lc) = Bit3
        If PackedFields(lc) And Bit4 Then DisposalMethod(lc) = DisposalMethod(lc) Or Bit2
        If PackedFields(lc) And Bit3 Then DisposalMethod(lc) = DisposalMethod(lc) Or Bit1
    
        If PackedFields(lc) And Bit2 Then UserInputFlag(lc) = True
    
        If PackedFields(lc) And Bit1 Then TransparentColorFlag(lc) = True
        lngCurPosition = lngCurPosition + lenGraphicControlExtension
         
           
        Case PlainTextExtension
        ' Jump to start of Plain Text Data Sub Blocks
        lngCurPosition = lngCurPosition + bArray(lngCurPosition + 14)
        ' if Next byte is 0 then this is the Block terminator
        'If bArray(lngCurPosition + 1) <> 0 Then
        ' Keep reading Comment Blocks until done
        Do While bArray(lngCurPosition + 1) <> 0
            lngCurPosition = lngCurPosition + bArray(lngCurPosition + 1)
        Loop
        'End If
                 
        Case Else
        End Select
    
    ' If not a Block starting with ExtensionIntroducer
    ' we fall through to here
    End If
    
    ' Update our position to continue in loop
    lngCurPosition = lngCurPosition + 1
        
        
    ' Check to make sure we are not at the end of the file
    If bArray(lngCurPosition) = Trailer Then Exit Do
    If lngCurPosition >= FLength Then Exit Do

    lngRet = 0
     
 
Loop
    
    ' OK if we get to here than we are at the start  of the Image Descriptor Block
    ' or we are all done processing the individual GIf Frames.
    
    
    ' Check to make sure we are not at the end of the file
    If bArray(lngCurPosition) = Trailer Then Exit Do
        If lngCurPosition >= FLength Then Exit Do
        
        
        ' OK let's jump over Image Descriptor Block
        ' and the actual Image Data so we can copy this
        ' Gif Frame to a Temp file.
         ' Here we can derive key props concerning the
         ' playback of this Specific GIF Frame.
         ' OK let's fill in our variables we derive from this block.
        apiCopyMemory ImageLeft(lc), bArray(lngCurPosition + 1), 2
        apiCopyMemory ImageTop(lc), bArray(lngCurPosition + 3), 2
        apiCopyMemory ImageWidth(lc), bArray(lngCurPosition + 5), 2
        apiCopyMemory ImageHeight(lc), bArray(lngCurPosition + 7), 2
        apiCopyMemory PackedFields(lc), bArray(lngCurPosition + 9), 1
        
        
        ' Let's derive our props from the packed Bit fields
    If PackedFields(lc) And Bit8 Then LocalColorTableFlag(lc) = True
    If PackedFields(lc) And Bit7 Then InterLaceFlag(lc) = True
    If PackedFields(lc) And Bit6 Then LSortFlag(lc) = True
    
    ' SizeOfLocalColorTable variable is a Byte with really only 3 bits significant
    If PackedFields(lc) And Bit3 Then SizeOfLocalColorTable(lc) = Bit3
    If PackedFields(lc) And Bit2 Then SizeOfLocalColorTable(lc) = SizeOfLocalColorTable(lc) Or Bit2
    If PackedFields(lc) And Bit1 Then SizeOfLocalColorTable(lc) = SizeOfLocalColorTable(lc) Or Bit1
    
' is there a Local Color Table?
If LocalColorTableFlag(lc) Then
        ' Calculate size of Local Color Table
        ' to calculate offset to jump to start of next Block
        ' Color Table = RGB Triple,  3 bytes per entry
        ' Just changed line below to fix problem of starting
        ' to copy color table 2 bytes to soon
        ' 1 byte was index on array other is lngcurposition
        apiCopyMemory LocalColorTable(0), bArray(lngCurPosition + 1), (3 * (2 ^ (SizeOfLocalColorTable(lc) + 1)))
        ' Copy over this LocalColorTable to our
        ' array of LocalColorTables. I forgot that I
        ' need to store an array of Local Color Tables.
        ' This is my quick fix until I can come back and
        ' redo the code for the next version!
       ' apiCopyMemory arrayLocalColorTables(0), LocalColorTable(0), (3 * (2 ^ (SizeOfLocalColorTable(lc) + 1)))
        
        lngStartLocalColorTable = lngCurPosition + 1
      
     '*****************
     'Normal logic resumes here leave alone!!!!!!!!!!!
        
        ' Skip over length of our Local Color Table
        lngCurPosition = lngCurPosition + (3 * (2 ^ (SizeOfLocalColorTable(lc) + 1)))
End If
      
    ' Add on length of this Image Descriptor Block
      lngCurPosition = lngCurPosition + lenImageDescriptor
     
     ' Let's jump to First Byte of Image Data
     ' This is the LZW Minimum Code Size
     'lngCurPosition = lngCurPosition + 1
     apiCopyMemory LZWMinimumCodeSize(lc), bArray(lngCurPosition), 1
     
     ' For Image Data Block there is no ZERO Block Terminator
     ' Like there is for the Control Blocks
     ' So we need to Check the first byte of the
     ' Data Block which is the Size field
     '  to find out when we are done reading
     ' Now we need to skip over Image Data Sub Blocks
      'lngCurPosition = lngCurPosition + 1
     Do While bArray(lngCurPosition + 1) <> 0
            lngCurPosition = lngCurPosition + bArray(lngCurPosition + 1)
        lngCurPosition = lngCurPosition + 1
        Loop
     
     
    ' Finally our lngCurPosition is now at end of
    ' this individual GIF Frame
    ' We'll need to add one more byte to allow for TRAILER(&H3B)
    ' that we need to place at end of the file.
    lngCurPosition = lngCurPosition + 1
    lngGifEnd = lngCurPosition
    
    
'****  DEBUG  *****
' ***  SKIP *******

'GoTo skip_trans
    
    
  ' **** START OF REPLACE DUPLICATE TRANSPARENT RGB VALUES ****
  

'*******************************************************************
' Let's make sure that if there is a Transparent Color it is
' not the same value as any Color in the Bitmap.

' The reason the TransparentColorIndex value works is that
' this index is ZERO based. This means even when the last palette
' index is specified as the Transparent index value we are in effect
' using this index and pointing to a position 3 bytes before the
' end of the ColorTable
        
If TransparentColorFlag(lc) Then
        lngIndexDuplicate = -1
        If LocalColorTableFlag(lc) Then
            apiCopyMemory bTransparentarray(0), LocalColorTable(TransparentColorIndex(lc) * 3), 3
            For x = 0 To (3 * (2 ^ (SizeOfLocalColorTable(lc) + 1))) - 3 Step 3
            apiCopyMemory bTemparray(0), LocalColorTable(x), 3
            ' Let's store last highest value we've seen through this loop.
            ' When done this will be the second largest value in the palette
            'lngMaxPrevious = lngMax
            If RGB(bTemparray(0), bTemparray(1), bTemparray(2)) = RGB(bTransparentarray(0), bTransparentarray(1), bTransparentarray(2)) Then
                ' check and ensure we are bot matching up with our Transparent Index itself!!
                If (TransparentColorIndex(lc) * 3) <> x Then lngIndexDuplicate = x
            End If
            Next x
            ' We are done loop.
            
            Else
            
            apiCopyMemory bTransparentarray(0), GlobalColorTable(TransparentColorIndex(lc) * 3), 3
            For x = 0 To (3 * (2 ^ (SizeOfGlobalColorTable + 1))) - 3 Step 3
            apiCopyMemory bTemparray(0), GlobalColorTable(x), 3
            ' Let's store last highest value we've seen through this loop.
            ' When done this will be the second largest value in the palette
            'lngMaxPrevious = lngMax
            If RGB(bTemparray(0), bTemparray(1), bTemparray(2)) = RGB(bTransparentarray(0), bTransparentarray(1), bTransparentarray(2)) Then
            ' check and ensure we are bot matching up with our Transparent Index itself!!
                If (TransparentColorIndex(lc) * 3) <> x Then lngIndexDuplicate = x
            End If
            
            Next x
            ' We are done loop.
        End If
            
    ' Was there a duplicate value
    If lngIndexDuplicate <> -1 Then
        ' Now let's compare Transparent color to rest of color table
        'If TransparentColorFlag(lc) Then
        ' Call our function. ByRef return on byte array we pass.
        'lngBool = fCheckTransparent(bTemparray)
        ' Find the largest RGB value
        lngMax = 0
        If LocalColorTableFlag(lc) Then
            For x = 0 To (3 * (2 ^ (SizeOfLocalColorTable(lc) + 1))) - 3 Step 3
            apiCopyMemory bTemparray(0), LocalColorTable(x), 3
            ' Let's store last highest value we've seen through this loop.
            ' When done this will be the second largest value in the palette
                If RGB(bTemparray(0), bTemparray(1), bTemparray(2)) > lngMax Then
                    lngMaxPrevious = lngMax
                    lngMax = RGB(bTemparray(0), bTemparray(1), bTemparray(2))
                Else
                If RGB(bTemparray(0), bTemparray(1), bTemparray(2)) > lngMaxPrevious Then lngMaxPrevious = RGB(bTemparray(0), bTemparray(1), bTemparray(2))
                End If
            Next x
            ' We are done loop. Let's calculate a new RGB value for
            ' the Transparency Color. We'll make it halfway between the
            ' second and the largest RGB values
            lngNewTransparent = lngMax - ((lngMax - lngMaxPrevious / 2))
            ' Store this value back in the appropriate ColorTable array
            ' and the raw byte array that will be written
            ' to the disk as a temp Gif file.
            ' Write to ColorTable
            
            'TransparentColorIndex(lc) * 3)
            LocalColorTable(3 * TransparentColorIndex(lc)) = (lngNewTransparent And &HFF)
            LocalColorTable((3 * TransparentColorIndex(lc)) + 1) = (lngNewTransparent And &HFF00&) \ &H100
            LocalColorTable((3 * TransparentColorIndex(lc)) + 2) = (lngNewTransparent And &HFF0000) \ &H10000
            
            ' Write to raw byte array
            bArray(lngStartLocalColorTable + (3 * TransparentColorIndex(lc))) = (lngNewTransparent And &HFF)
            bArray(lngStartLocalColorTable + (3 * TransparentColorIndex(lc)) + 1) = (lngNewTransparent And &HFF00&) \ &H100
            bArray(lngStartLocalColorTable + (3 * TransparentColorIndex(lc)) + 2) = (lngNewTransparent And &HFF0000) \ &H10000
            
        Else
            lngMax = 0
             For x = 0 To (3 * (2 ^ (SizeOfGlobalColorTable + 1))) - 3 Step 3
            apiCopyMemory bTemparray(0), GlobalColorTable(x), 3
            ' Let's store last highest value we've seen through this loop.
            ' When done this will be the second largest value in the palette
            
            If RGB(bTemparray(0), bTemparray(1), bTemparray(2)) > lngMax Then
                lngMaxPrevious = lngMax
                lngMax = RGB(bTemparray(0), bTemparray(1), bTemparray(2))
            
            Else
            If RGB(bTemparray(0), bTemparray(1), bTemparray(2)) > lngMaxPrevious Then lngMaxPrevious = RGB(bTemparray(0), bTemparray(1), bTemparray(2))
            End If
            
            Next x
            ' We are done loop. Let's calculate a new RGB value for
            ' the Transparency Color. We'll make it halfway between the
            ' second and the largest RGB values
            lngNewTransparent = lngMax - ((lngMax - lngMaxPrevious / 2))
            ' Store this value back in the appropriate ColorTable array
            ' and the raw byte array that will be written
            ' to the disk as a temp Gif file.
            ' Write to ColorTable
            GlobalColorTable(3 * TransparentColorIndex(lc)) = (lngNewTransparent And &HFF)
            GlobalColorTable((3 * TransparentColorIndex(lc)) + 1) = (lngNewTransparent And &HFF00&) \ &H100
            GlobalColorTable((3 * TransparentColorIndex(lc)) + 2) = (lngNewTransparent And &HFF0000) \ &H10000
                        
            ' Write to raw byte array
            bArray(lngStartGlobalColorTable + (3 * TransparentColorIndex(lc))) = (lngNewTransparent And &HFF)
            bArray(lngStartGlobalColorTable + (3 * TransparentColorIndex(lc)) + 1) = (lngNewTransparent And &HFF00&) \ &H100
            bArray(lngStartGlobalColorTable + (3 * TransparentColorIndex(lc)) + 2) = (lngNewTransparent And &HFF0000) \ &H10000
            
        End If

    End If
        
End If
' **** END OF REPLACE DUPLICATE TRANSPARENT RGB VALUES ****
    
    
' For debugging
skip_trans:
    
' *******START LOOP *************
 'Resize all of our storage arrays each time we come through
 ' this main loop.
' Is this the very first time through the loop?
If blFirstTime Then
'
    ReDim mGifStart(0)
    ReDim mGifEnd(0)
    ' Set our Flag
    blFirstTime = False
    
Else
    ReDim Preserve mGifStart(UBound(mGifStart) + 1)
    ReDim Preserve mGifEnd(UBound(mGifEnd) + 1)
End If
    
    'Debug.Print "Gif Start:" & lngGifStart
    ' Let's store the actual values we generated in this loop
    mGifStart(UBound(mGifStart)) = lngGifStart
    mGifEnd(UBound(mGifEnd)) = lngGifEnd
                            
                
    ' Advance Current Position to start lookin for the NEXT GIF FRAME!
    lngCurPosition = lngCurPosition + 1
    ' Reset start of next GIF Frame
    lngGifStart = lngCurPosition
     'WriteTemp Gif
     ' Loop and continue
     ' *******************
     
' Check to make sure we are not at the end of the file
    If bArray(lngCurPosition) = Trailer Then Exit Do
     '   If lngCurPosition < FLength Then
     
' Increment our Loop Counter
lc = lc + 1
Loop
      
    
' If we get here then we have should have some
' GIF Frame pointers in our Arrays

' Let's take the start and end offsets for our
' individual Gif Frames and get a StdPic object
' by using LoadPicture
' We can then use this Handle directly as a hBitmap!
' No kidding!<bg>
   
' For System Temp Folder
' and temp unique filename

Dim strFixed  As String * Pathlen
Dim sec As SECURITY_ATTRIBUTES
     Dim lngBytesWritten As Long

' Handle for our File
Dim hFile As Long
 
' Loop Counter
 Dim GifLoop As Long
 
' Init loop counter
 GifLoop = 0
 
' Reset Index for array of Start/Stop points
 ctr = 0

 For ctr = 0 To UBound(mGifStart)
    
' Get the Systems Temp path
 ' Returns Length of path(num characters in path)
 lngRet = GetTempPath(Pathlen, strPath)
 ' Chop off NULLS and trailing "\"
 strPath = Left(strPath, lngRet) & Chr(0)
 
 ' Now need a unique Filename
 ' locked from a previous aborted attemp.
 strPathandFileName = GetUniqueFilename(strPath, Str(ctr) & Chr(0), "GIF")
 

sec.bInheritHandle = True
 sec.lpSecurityDescriptor = 0
 sec.nLength = Len(sec)
    
 hFile = CreateFile(strPathandFileName, GENERIC_WRITE, 0&, sec, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0)
 
 'ctr = gifstart(ctr)
 ' Write Common Gif File Header
 ' From start of File until Start of First Gif frame
 lngRet = WriteFile(hFile, bArray(1), mGifStart(0) - 1, lngBytesWritten, 0)
 ' Write out entire GIf Frame
 ' This will start at our stored start point.
 ' The length will be our stored ending point minus
 ' the starting point. Think about it!<bg>
 lngRet = WriteFile(hFile, bArray(mGifStart(ctr)), mGifEnd(ctr) - mGifStart(ctr), lngBytesWritten, 0)
 ' Write Block Terminator - ZERO
 lngRet = WriteFile(hFile, 0, 1, lngBytesWritten, 0)
 
 ' Write DUMMY Control Block
 ' Some programs depend on seeing the next Control Block to
 ' know the previous data block is done!!!!
 lngRet = WriteFile(hFile, &HF921, 2, lngBytesWritten, 0)
 
 
 ' Write the Trailer Block
 lngRet = WriteFile(hFile, Trailer, 1, lngBytesWritten, 0)
  'Debug.Print "ctr:" & ctr & "Start:" & mGifStart(ctr) & " :" & strPathandFileName
 ' Close the Temp GIF file
 CloseHandle (hFile)
 

' Need as many StdPicture objects as there are Gif Frames
' hStdPicture is declared at the module level.
ReDim Preserve hStdPicture(ctr)
' Load in the Frame we just saved to disk.
Set hStdPicture(ctr) = LoadPicture(strPathandFileName)

' DELETE the TEMP GIF FILE
    Kill strPathandFileName

' Loop and create next Frame until done
Next

' ** All done splitting Gif into its constituent frames **


' Let's load the first Frame of the Animated Gif
' into the Image Control. We do this by simply
' loading the original Animated Gif file into the
' Image control as we would normally.
Set mImageCtl.Picture = LoadPicture(strGifFileName)

' Now we need to Create a DibSection matching the
' properties of this Animated GIf
fCreateBitMap


exit_Gif:
Exit Function

' We now have an array of
err_NoGif:
 ' File is not an Animated Gif
 MsgBox "Sorry, not an Animated Gif file", vbOKOnly, "Not a Valid Animated Gif File!"
 Resume exit_Gif
 
 End Function


' Function to finally render the individual Gif Frames
Public Sub RenderGif()
'************** RENDER **********************
' ************* STDPIC **********************

' ERROR CHECKING -
On Error Resume Next
Dim varTemp As Long
varTemp = hStdPicture(0)
If varTemp < 1 Then Exit Sub


' Get and Create our Device Context handles
hDCApp = Form1.Picture1.hDC 'apiGetDC(Form1.hwnd) '0) 'Forms!frmImage.hwnd) 'Application.hWndAccessApp)
hDCtemp = apiCreateCompatibleDC(Form1.Picture1.hDC) 'hDCApp)

' Reset Index for array of Start/Stop points
ctr = 0

' Setup our Loop
For ctr = 0 To UBound(mGifStart)

' See if user want to STOP
If StopRender Then Exit Sub

' Get the Original Images Width and Height props
lngRet = apiGetObject(hStdPicture(ctr), Len(bm), bm)

' Select our Image into its DC
 hBmpOrig = apiSelectObject(hDCtemp, hStdPicture(ctr))
 
' Check Transparent Color Flag
' Clear out our temp byte array
Erase bTemparray


If TransparentColorFlag(ctr) Then
    If LocalColorTableFlag(ctr) Then
        apiCopyMemory bTemparray(0), LocalColorTable(TransparentColorIndex(ctr) * 3), 3
    Else
        apiCopyMemory bTemparray(0), GlobalColorTable((TransparentColorIndex(ctr) * 3)), 3
    End If
Else
' Grab Background Color
    If GlobalColorTableFlag Then
    apiCopyMemory bTemparray(0), GlobalColorTable((BackgroundColorIndex * 3)), 3
    End If
End If

' Set a Rectangle equal to the size of this Gif Frame
rc.Bottom = ImageHeight(ctr) 'bm.bmHeight 'ImageHeight(lc) 'bm.bmHeight
rc.Right = ImageWidth(ctr) 'bm.bmWidth ' (lc) 'bm.bmWidth
rc.Top = ImageTop(ctr)
rc.Left = ImageLeft(ctr)


' Setup Frame delay
' Add in UserDefined Delay
If DelayTime(ctr) < 100 Then
    Sleep (DelayTime(ctr) * 10) + mUserDelay
Else
    Sleep 100 + mUserDelay
End If

' OK What do we do after we rendered that last Frame

Select Case DisposalMethod(ctr)

Case 0, 1
' do nothing

Case 2
'*******NEEDS WORK
' Needs to copy BACKGROUND COLOR directly
' because btemparray could be holding Transparent color
' erase to background.
' Not used here. We use PictureBox.Background Color
apiCopyMemory bBGarray(0), GlobalColorTable((BackgroundColorIndex * 3)), 3

' Make sure we can handle System Colors
lngTemp = ConvertSystemColor(mImageCtl.BackColor)
hBrush = apiCreateSolidBrush(lngTemp)
hOrigBrush = apiSelectObject(hdc1, hBrush)

Dim rcTemp As RECTL
rcTemp.Right = bmap.bmWidth
rcTemp.Bottom = bmap.bmHeight
' Fill the Bitmap with the Control's Background COlor
lngRet = apiFillRect(hdc1, rcTemp, hBrush)
hBrush = apiSelectObject(hdc1, hOrigBrush)
lngRet = apiDeleteObject(hBrush)
        
        
Case 3
' Restore previous frame
' not done yet

Case Else
End Select

If TransparentColorFlag(ctr) Then
TransparentBlt hdc1, hDCApp, _
   hDCtemp, rc, 0 + rc.Left, 0 + rc.Top, RGB(bTemparray(0), bTemparray(1), bTemparray(2)) 'vbWhite '

Else
lngRet = apiBitBlt(hdc1, rc.Left, rc.Top, rc.Right, rc.Bottom, hDCtemp, 0, 0, SRCCOPY)   'WHITENESS)

' Copy from Mem DC to PictureBox DC0 + rc.Top
lngRet = apiBitBlt(hDC, 0, 0, bmap.bmWidth, bmap.bmHeight, _
            hdc1, 0, 0, SRCCOPY)
DoEvents
End If

' Cleanup
' ReSelect the original Bitmap back into its DC
 lngRet = apiSelectObject(hDCtemp, hBmpOrig)
 
' Continue looping until a file is created for all frames
' of the Animated Gif.

' ***** DEBUG

'If TransparentColorFlag(ctr) Then
   ' If LocalColorTableFlag(ctr) Then
    '    apiCopyMemory bTemparray(0), LocalColorTable(TransparentColorIndex(ctr) * 3), 3
    'Else
    '    apiCopyMemory bTemparray(0), GlobalColorTable((TransparentColorIndex(ctr) * 3)), 3
    'End If


' **Give VB time slice to keep controls responsive!
DoEvents
Next ctr

' **********************
' OK we now have an array of StdPicture objects
' containing the individual Frames of our Animated GIf

' Release as soon as we are done with the DC
lngRet = apiReleaseDC(0&, hDCApp)
lngRet = apiDeleteDC(hDCtemp)
'lngRet = apiDeleteDC(hdc1)
DoEvents
End Sub



Public Sub CleanUp()
' ***********  CLEANUP ******************
' StdPic objects are set to nothing in Class Terminate
' But we'll do it here for now for debugging
' Also need to consider Looping and the fact that
' the Class Terminate is only called when the FOrm exits
' we need to delete any StdPic objects whenever a new
' GIF is loaded for display
' Reset handles to StdPic objects
On Error Resume Next
Dim varTemp As Long
varTemp = hStdPicture(0)
If varTemp > 1 Then
For x = 0 To UBound(hStdPicture) '- 1
Set hStdPicture(x) = Nothing
Next
End If


Erase PackedFields()
Erase ImageLeft()
Erase ImageTop()
Erase ImageWidth()
Erase ImageHeight()
Erase LSortFlag()
Erase LocalColorTableFlag()
Erase InterLaceFlag()
Erase SizeOfLocalColorTable()

Erase LZWMinimumCodeSize()
Erase DelayTime()
Erase TransparentColorIndex()
Erase DisposalMethod()
Erase UserInputFlag()
Erase TransparentColorFlag()
'Erase arrayLocalColorTables()
        
End Sub

   
' The all important let's actually
' do a Transparent Blit!
' Adapted from Code including:
' KB article Q94961
' KB article Q79212
' KB article Q187568
' VBPJ July 1995 Carl Franklin  "TransBlit"
' VBNET, Creating a Transparent Bitmap by "Maarten Roode"
' Bruce McKinney's "Hardcore Visual Basic"
' Rod Stephen's "Visual Basic Graphics Programming"
' VBPJ, January 1997 Karl Peterson's TransBlit

Private Sub TransparentBlt(DestinationDC As Long, _
TempDestinationDC As Long, SourceDC As Long, SourceRectangle As RECTL, _
DestinationX As Integer, DestinationY As Integer, TransColor As Long)
 
   
' temp var for DC's current BackColor
Dim OrigBackColor As Long
' Width of Bitmap
Dim intWidth As Integer
' Height of Bitmap
Dim intHeight As Integer

' Temp Bitmaps
Dim hBitmapMaskMono As Long
Dim hBitmapInverted As Long
Dim hBitmapResultDestination As Long
Dim hBitmapResultSource As Long
Dim hBitmapPreviousInverted As Long
Dim hBitmapOrigMask As Long
Dim hBitmapPreviousSource As Long
Dim hBitmapPreviousDestination As Long

' Temp Device Contexts
Dim hDCMaskMono As Long
Dim hDCMaskInverted As Long
Dim hDCResult As Long
Dim hDCResultSource As Long

' Bitmap dimensions
intWidth = SourceRectangle.Right
intHeight = SourceRectangle.Bottom
 
'Temp DC's for our Bitmap Masks
hDCResult = apiCreateCompatibleDC(TempDestinationDC)
hDCResultSource = apiCreateCompatibleDC(TempDestinationDC)
hDCMaskMono = apiCreateCompatibleDC(TempDestinationDC)
hDCMaskInverted = apiCreateCompatibleDC(TempDestinationDC)

' Temp Bitmaps for our Masks
hBitmapMaskMono = CreateBitmap(intWidth, intHeight, 1, 1, ByVal 0&)
hBitmapInverted = CreateBitmap(intWidth, intHeight, 1, 1, ByVal 0&)

' Select Temp Bitmap Masks into Temp DC's
hBitmapResultDestination = apiCreateCompatibleBitmap(TempDestinationDC, intWidth, intHeight)
hBitmapResultSource = apiCreateCompatibleBitmap(TempDestinationDC, intWidth, intHeight)
hBitmapOrigMask = apiSelectObject(hDCMaskMono, hBitmapMaskMono)
hBitmapPreviousInverted = apiSelectObject(hDCMaskInverted, hBitmapInverted)
hBitmapPreviousDestination = apiSelectObject(hDCResult, hBitmapResultDestination)
hBitmapPreviousSource = apiSelectObject(hDCResultSource, hBitmapResultSource)
  
 
' Create a monochrome mask from the Source Image.
' We do this by Setting the Background Color of
' the Source DC to the color we want Transparent.

OrigBackColor = apiSetBkColor(SourceDC, TransColor)
lngRet = apiBitBlt(hDCMaskMono, 0, 0, intWidth, intHeight, SourceDC, _
        0, 0, SRCCOPY)
             
' Reset Original BackGround Color
TransColor = apiSetBkColor(SourceDC, OrigBackColor)
 
' Now Invert the Mask
lngRet = apiBitBlt(hDCMaskInverted, 0, 0, intWidth, intHeight, _
              hDCMaskMono, 0, 0, NOTSRCCOPY)
 
 ' Grab Bitmap from our Source DC
lngRet = apiBitBlt(hDCResult, 0, 0, intWidth, intHeight, _
             hdc1, DestinationX, DestinationY, SRCCOPY)
 
 
 ' AND with our Monochrome mask
lngRet = apiBitBlt(hDCResult, 0, 0, intWidth, intHeight, _
              hDCMaskMono, 0, 0, SRCAND)
              

' Grab the overlapping area
lngRet = apiBitBlt(hDCResultSource, 0, 0, intWidth, intHeight, SourceDC, _
             0, 0, SRCCOPY)
                  
' AND with inverse Monochrome Mask
lngRet = apiBitBlt(hDCResultSource, 0, 0, intWidth, intHeight, _
              hDCMaskInverted, 0, 0, SRCAND)
 
' XOR the 2 bitmaps
lngRet = apiBitBlt(hDCResult, 0, 0, intWidth, intHeight, _
              hDCResultSource, 0, 0, SRCINVERT)
 
' Copy the results to our Temp DC
' We do it this way to eliminate any "flickering"
lngRet = apiBitBlt(DestinationDC, DestinationX, DestinationY, intWidth, intHeight, _
              hDCResult, 0, 0, SRCCOPY)
                              
' Copy from Mem DC to PictureBox DC
  lngRet = apiBitBlt(hDC, 0, 0, bmap.bmWidth, bmap.bmHeight, _
              hdc1, 0, 0, SRCCOPY)
              
' Now comes the fun part..we get to cleanup!

' Select all of the original Bitmaps back into
' the Temp DC's.
hBitmapMaskMono = apiSelectObject(hDCMaskMono, hBitmapOrigMask)
hBitmapInverted = apiSelectObject(hDCMaskInverted, hBitmapPreviousInverted)
hBitmapResultDestination = apiSelectObject(hDCResult, hBitmapPreviousDestination)
hBitmapResultSource = apiSelectObject(hDCResultSource, hBitmapPreviousSource)

' Now delete all of our Temp Bitmaps
apiDeleteObject hBitmapMaskMono
apiDeleteObject hBitmapInverted
apiDeleteObject hBitmapResultDestination
apiDeleteObject hBitmapResultSource

' Finally delete all of the Temp DC's
apiDeleteDC hDCMaskMono
apiDeleteDC hDCMaskInverted
apiDeleteDC hDCResult
apiDeleteDC hDCResultSource

' All done!
End Sub

' Function to call API File Browser
Public Sub SGetGifFileName()

Dim strFilter As String
Dim strInputFileName As String
Dim strfName As String
Dim blRet As Boolean
strFilter = ahtAddFilterItem(strFilter, "Animated Gif (*.GIF)", "*.GIF")
strGifFileName = ahtCommonFileOpenSave(Filter:=strFilter, OpenFile:=True, _
                DialogTitle:="Please select an input file...", _
                flags:=ahtOFN_HIDEREADONLY)
DoEvents
End Sub

' Function used in Access Version.
' No direct support for Resources
' and I was trying to find a method
' to keep everything in this one file.
' Leaving in for now for educational purposes.<bg>
Private Sub sMakeOfficePal256()
' Holds our byte array of
' 256 RGBQUADS(1024 bytes)
Dim varArray As Variant


' 7 arrays of Variants so that we
' can use the ARRAY function to load
' the data directly from our Hex editor.

Dim arr1 As Variant
Dim arr2 As Variant
Dim arr3 As Variant
Dim arr4 As Variant
Dim arr5 As Variant
Dim arr6 As Variant
Dim arr7 As Variant
Dim arr8 As Variant


arr1 = Array(&H0, &H0, &H0, &H0, &H0, &H0, &H80, &H0, &H0, &H80, _
 &H0, &H0, &H0, &H80, &H80, &H0, &H80, &H0, &H0, &H0, &H80, &H0, &H80, &H0, &H80, &H80, _
 &H0, &H0, &HC0, &HC0, &HC0, &H0, &HC0, &HDC, &HC0, &H0, &HF0, &HCA, &HA6, &H0, &H4, &H4, _
 &H4, &H0, &H8, &H8, &H8, &H0, &HC, &HC, &HC, &H0, &H11, &H11, &H11, &H0, &H16, &H16, _
 &H16, &H0, &H1C, &H1C, &H1C, &H0, &H22, &H22, &H22, &H0, &H29, &H29, &H29, &H0, &H55, &H55, _
 &H55, &H0, &H4D, &H4D, &H4D, &H0, &H42, &H42, &H42, &H0, &H39, &H39, &H39, &H0, &H80, &H7C)
 
 arr2 = Array(&HFF, &H0, &H50, &H50, &HFF, &H0, &H93, &H0, &HD6, &H0, &HFF, &HEC, &HCC, &H0, &HC6, &HD6, _
 &HEF, &H0, &HD6, &HE7, &HE7, &H0, &H90, &HA9, &HAD, &H0, &H0, &H0, &H33, &H0, &H0, &H0, _
 &H66, &H0, &H0, &H0, &H99, &H0, &H0, &H0, &HCC, &H0, &H0, &H33, &H0, &H0, &H0, &H33, _
 &H33, &H0, &H0, &H33, &H66, &H0, &H0, &H33, &H99, &H0, &H0, &H33, &HCC, &H0, &H0, &H33, _
 &HFF, &H0, &H0, &H66, &H0, &H0, &H0, &H66, &H33, &H0, &H0, &H66, &H66, &H0, &H0, &H66, _
 &H99, &H0, &H0, &H66, &HCC, &H0, &H0, &H66, &HFF, &H0, &H0, &H99, &H0, &H0, &H0, &H99, _
 &H33, &H0, &H0, &H99, &H66, &H0, &H0, &H99, &H99, &H0, &H0, &H99, &HCC, &H0, &H0, &H99, _
&HFF, &H0, &H0, &HCC, &H0, &H0, &H0, &HCC, &H33, &H0, &H0, &HCC, &H66, &H0, &H0, &HCC, _
 &H99, &H0, &H0, &HCC, &HCC, &H0, &H0, &HCC, &HFF, &H0, &H0, &HFF, &H66, &H0, &H0, &HFF)
 

arr3 = Array(&H99, &H0, &H0, &HFF, &HCC, &H0, &H33, &H0, &H0, &H0, &H33, &H0, &H33, &H0, &H33, &H0, _
 &H66, &H0, &H33, &H0, &H99, &H0, &H33, &H0, &HCC, &H0, &H33, &H0, &HFF, &H0, &H33, &H33, _
 &H0, &H0, &H33, &H33, &H33, &H0, &H33, &H33, &H66, &H0, &H33, &H33, &H99, &H0, &H33, &H33, _
 &HCC, &H0, &H33, &H33, &HFF, &H0, &H33, &H66, &H0, &H0, &H33, &H66, &H33, &H0, &H33, &H66, _
 &H66, &H0, &H33, &H66, &H99, &H0, &H33, &H66, &HCC, &H0, &H33, &H66, &HFF, &H0, &H33, &H99, _
&H0, &H0, &H33, &H99, &H33, &H0, &H33, &H99, &H66, &H0, &H33, &H99, &H99, &H0, &H33, &H99, _
&HCC, &H0, &H33, &H99, &HFF, &H0, &H33, &HCC, &H0, &H0, &H33, &HCC, &H33, &H0, &H33, &HCC, _
 &H66, &H0, &H33, &HCC, &H99, &H0, &H33, &HCC, &HCC, &H0, &H33, &HCC, &HFF, &H0, &H33, &HFF, _
 &H33, &H0, &H33, &HFF, &H66, &H0, &H33, &HFF, &H99, &H0, &H33, &HFF, &HCC, &H0, &H33, &HFF)


arr4 = Array(&HFF, &H0, &H66, &H0, &H0, &H0, &H66, &H0, &H33, &H0, &H66, &H0, &H66, &H0, &H66, &H0, _
 &H99, &H0, &H66, &H0, &HCC, &H0, &H66, &H0, &HFF, &H0, &H66, &H33, &H0, &H0, &H66, &H33, _
 &H33, &H0, &H66, &H33, &H66, &H0, &H66, &H33, &H99, &H0, &H66, &H33, &HCC, &H0, &H66, &H33, _
 &HFF, &H0, &H66, &H66, &H0, &H0, &H66, &H66, &H33, &H0, &H66, &H66, &H66, &H0, &H66, &H66, _
 &H99, &H0, &H66, &H66, &HCC, &H0, &H66, &H99, &H0, &H0, &H66, &H99, &H33, &H0, &H66, &H99, _
 &H66, &H0, &H66, &H99, &H99, &H0, &H66, &H99, &HCC, &H0, &H66, &H99, &HFF, &H0, &H66, &HCC, _
 &H0, &H0, &H66, &HCC, &H33, &H0, &H66, &HCC, &H99, &H0, &H66, &HCC, &HCC, &H0, &H66, &HCC, _
&HFF, &H0, &H66, &HFF, &H0, &H0, &H66, &HFF, &H33, &H0, &H66, &HFF, &H99, &H0, &H66, &HFF, _
 &HCC, &H0, &HCC, &H0, &HFF, &H0, &HFF, &H0, &HCC, &H0, &H99, &H99, &H0, &H0, &H99, &H33)

arr5 = Array(&H99, &H0, &H99, &H0, &H99, &H0, &H99, &H0, &HCC, &H0, &H99, &H0, &H0, &H0, &H99, &H33, _
 &H33, &H0, &H99, &H0, &H66, &H0, &H99, &H33, &HCC, &H0, &H99, &H0, &HFF, &H0, &H99, &H66, _
 &H0, &H0, &H99, &H66, &H33, &H0, &H99, &H33, &H66, &H0, &H99, &H66, &H99, &H0, &H99, &H66, _
 &HCC, &H0, &H99, &H33, &HFF, &H0, &H99, &H99, &H33, &H0, &H99, &H99, &H66, &H0, &H99, &H99, _
 &H99, &H0, &H99, &H99, &HCC, &H0, &H99, &H99, &HFF, &H0, &H99, &HCC, &H0, &H0, &H99, &HCC, _
 &H33, &H0, &H66, &HCC, &H66, &H0, &H99, &HCC, &H99, &H0, &H99, &HCC, &HCC, &H0, &H99, &HCC, _
&HFF, &H0, &H99, &HFF, &H0, &H0, &H99, &HFF, &H33, &H0, &H99, &HCC, &H66, &H0, &H99, &HFF, _
 &H99, &H0, &H99, &HFF, &HCC, &H0, &H99, &HFF, &HFF, &H0, &HCC, &H0, &H0, &H0, &H99, &H0, _
 &H33, &H0, &HCC, &H0, &H66, &H0, &HCC, &H0, &H99, &H0, &HCC, &H0, &HCC, &H0, &H99, &H33)

 arr6 = Array(&H0, &H0, &HCC, &H33, &H33, &H0, &HCC, &H33, &H66, &H0, &HCC, &H33, &H99, &H0, &HCC, &H33, _
 &HCC, &H0, &HCC, &H33, &HFF, &H0, &HCC, &H66, &H0, &H0, &HCC, &H66, &H33, &H0, &H99, &H66, _
 &H66, &H0, &HCC, &H66, &H99, &H0, &HCC, &H66, &HCC, &H0, &H99, &H66, &HFF, &H0, &HCC, &H99, _
 &H0, &H0, &HCC, &H99, &H33, &H0, &HCC, &H99, &H66, &H0, &HCC, &H99, &H99, &H0, &HCC, &H99, _
 &HCC, &H0, &HCC, &H99, &HFF, &H0, &HCC, &HCC, &H0, &H0, &HCC, &HCC, &H33, &H0, &HCC, &HCC, _
 &H66, &H0, &HCC, &HCC, &H99, &H0, &HCC, &HCC, &HCC, &H0, &HCC, &HCC, &HFF, &H0, &HCC, &HFF, _
 &H0, &H0, &HCC, &HFF, &H33, &H0, &H99, &HFF, &H66, &H0, &HCC, &HFF, &H99, &H0, &HCC, &HFF, _
 &HCC, &H0, &HCC, &HFF, &HFF, &H0, &HCC, &H0, &H33, &H0, &HFF, &H0, &H66, &H0, &HFF, &H0, _
 &H99, &H0, &HCC, &H33, &H0, &H0, &HFF, &H33, &H33, &H0, &HFF, &H33, &H66, &H0, &HFF, &H33)
 
arr7 = Array(&H99, &H0, &HFF, &H33, &HCC, &H0, &HFF, &H33, &HFF, &H0, &HFF, &H66, &H0, &H0, &HFF, &H66, _
 &H33, &H0, &HCC, &H66, &H66, &H0, &HFF, &H66, &H99, &H0, &HFF, &H66, &HCC, &H0, &HCC, &H66, _
 &HFF, &H0, &HFF, &H99, &H0, &H0, &HFF, &H99, &H33, &H0, &HFF, &H99, &H66, &H0, &HFF, &H99, _
 &H99, &H0, &HFF, &H99, &HCC, &H0, &HFF, &H99, &HFF, &H0, &HFF, &HCC, &H0, &H0, &HFF, &HCC, _
 &H33, &H0, &HFF, &HCC, &H66, &H0, &HFF, &HCC, &H99, &H0, &HFF, &HCC, &HCC, &H0, &HFF, &HCC, _
 &HFF, &H0, &HFF, &HFF, &H33, &H0, &HCC, &HFF, &H66, &H0, &HFF, &HFF, &H99, &H0, &HFF, &HFF, _
 &HCC, &H0, &H66, &H66, &HFF, &H0, &H66, &HFF, &H66, &H0, &H66, &HFF, &HFF, &H0, &HFF, &H66, _
 &H66, &H0, &HFF, &H66, &HFF, &H0, &HFF, &HFF, &H66, &H0, &H21, &H0, &HA5, &H0, &H5F, &H5F, _
 &H5F, &H0, &H77, &H77, &H77, &H0, &H86, &H86, &H86, &H0, &H96, &H96, &H96, &H0, &HCB, &HCB)
 
 arr8 = Array(&HCB, &H0, &HB2, &HB2, &HB2, &H0, &HD7, &HD7, &HD7, &H0, &HDD, &HDD, &HDD, &H0, &HE3, &HE3, _
 &HE3, &H0, &HEA, &HEA, &HEA, &H0, &HF1, &HF1, &HF1, &H0, &HF8, &HF8, &HF8, &H0, &HF0, &HFB, _
 &HFF, &H0, &HA4, &HA0, &HA0, &H0, &H80, &H80, &H80, &H0, &H0, &H0, &HFF, &H0, &H0, &HFF, _
&H0, &H0, &H0, &HFF, &HFF, &H0, &HFF, &H0, &H0, &H0, &HFF, &H0, &HFF, &H0, &HFF, &HFF, _
 &H0, &H0, &HFF, &HFF, &HFF, &H0)


Dim varTemp(0 To 7) As Variant
varTemp(0) = arr1
varTemp(1) = arr2
varTemp(2) = arr3
varTemp(3) = arr4
varTemp(4) = arr5
varTemp(5) = arr6
varTemp(6) = arr7
varTemp(7) = arr8

' Dump it all together in one array
varArray = fFillArray(varTemp)


Dim quad(0 To 255) As RGBQUAD
lngRet = GetDIBColorTable(hDC, 0, 256, quad(0))

Dim x As Long, y As Long
y = 0
For x = 0 To 255
    
    'bmh256.bmiColors(x).rgbRed = varArray(y)
    quad(x).RGBRed = varArray(y)
    y = y + 1
    
    'bmh256.bmiColors(x).rgbGreen = varArray(y)
    quad(x).RGBGreen = varArray(y)
    y = y + 1
    
    'bmh256.bmiColors(x).rgbBlue = varArray(y)
    quad(x).RGBBlue = varArray(y)
    y = y + 1
    
    'bmh256.bmiColors(x).rgbReserved = 0
    quad(x).rgbReserved = varArray(y)
    y = y + 1
Next x


'For X = 0 To 255
'quad(X).rgbBlue = GlobalColorTable(Y)
'quad(X).rgbGreen = GlobalColorTable(Y + 1)
'quad(X).rgbRed = GlobalColorTable(Y + 2)

' Fill in our BitmapInfo. Declared in General Declarations
'bmh256.bmiColors(X).rgbBlue = GlobalColorTable(Y)
'bmh256.bmiColors(X).rgbGreen = GlobalColorTable(Y + 1)
'bmh256.bmiColors(X).rgbRed = GlobalColorTable(Y + 2)
'bmh256.bmiColors(X).rgbReserved = 0

'Y = Y + 3
'Next X


lngRet = SetDIBColorTable(hDC, 0, 256, quad(0))

lngRet = GetDIBColorTable(hDC, 0, 256, quad(0))
End Sub


Private Function fFillArray(vTemp As Variant) As Variant
' Fill our 1024 element array with
' the elements from our 8 seperate Arrays
' Return the one complete Array

Dim arr1024(0 To 1023) As Byte
Dim x As Long, y As Long, z As Long, ctr As Long
Dim varArray As Variant
x = 0

For ctr = 0 To UBound(vTemp)
    varArray = vTemp(ctr)
    y = 0
    For z = 0 To UBound(varArray)
        arr1024(x) = varArray(y)
        x = x + 1
        y = y + 1
    Next z

Next ctr

fFillArray = arr1024
End Function


'
'
'arrlong1 = Array(&H0, &H3300, &H6600, &H9900, &HCC00, &HFF00, _
'&H33, &H3333, &H6633, &H9933, &HCC33, &HFF33, _
'&H66, &H3366, &H6666, &H9966, &HCC66, &HFF66, _
'&H99, &H3399, &H6699, &H9999, &HCC99, &HFF99, _
'&HCC, &H33CC, &H66CC, &H99CC, &HCCCC, &HFFCC, _
'&HFF, &H33FF, &H66FF, &H99FF, &HCCFF, &HFFFF, _
'&H330000, &H333300, &H336600, &H339900, &H33CC00, &H33FF00, _
'&H330033, &H333333, &H336633, &H339933, &H33CC33, &H33FF33, _
'&H330066, &H333366, &H336666, &H339966, &H33CC66, &H33FF66, _
'&H330099, &H333399, &H336699, &H339999, &H33CC99, &H33FF99, _
'&H3300CC, &H3333CC, &H3366CC, &H3399CC, &H33CCCC, &H33FFCC, _
'&H3300FF, &H3333FF, &H3366FF, &H3399FF, &H33CCFF, &H33FFFF, _
'&H660000, &H663300, &H666600, &H669900, &H66CC00, &H66FF00, _
'&H660033, &H663333, &H666633, &H669933, &H66CC33, &H66FF33, _
'&H660066, &H663366, &H666666, &H669966, &H66CC66, &H66FF66, _
'&H660099, &H663399, &H666699, &H669999, &H66CC99, &H66FF99, _
'&H6600CC, &H6633CC, &H6666CC, &H6699CC, &H66CCCC, &H66FFCC, _
'&H6600FF, &H6633FF, &H6666FF, &H6699FF, &H66CCFF, &H66FFFF, _
'&H990000, &H993300, &H996600, &H999900, &H99CC00, &H99FF00, _
'&H990033, &H993333, &H996633, &H999933, &H99CC33, &H99FF33, _
'&H990066, &H993366, &H996666, &H999966, &H99CC66, &H99FF66, _
'&H990099, &H993399, &H996699, &H999999, &H99CC99, &H99FF99, _
'&H9900CC, &H9933CC, &H9966CC, &H9999CC, &H99CCCC, &H99FFCC, _
'&H9900FF, &H9933FF, &H9966FF, &H9999FF, &H99CCFF, &H99FFFF)
'&HCC0000,&HCC3300,&HCC6600,&HCC9900,&HCCCC00,&HCCFF00,
'&HCC0033,&HCC3333,&HCC6633,&HCC9933,&HCCCC33,&HCCFF33
'&HCC0066,&HCC3366,&HCC6666,&HCC9966,&HCCCC66,&HCCFF66
'&HCC0099,&HCC3399,&HCC6699,&HCC9999,&HCCCC99,&HCCFF99
'&HCC00CC,&HCC33CC,&HCC66CC,&HCC99CC,&HCCCCCC,&HCCFFCC
'&HCC00FF,&HCC33FF,&HCC66FF,&HCC99FF,&HCCCCFF,&HCCFFFF
'&HFF0000,&HFF3300,&HFF6600,&HFF9900,&HFFCC00,&HFFFF00
'&HFF0033,&HFF3333,&HFF6633,&HFF9933,&HFFCC33,&HFFFF33
'&HFF0066,&HFF3366,&HFF6666,&HFF9966,&HFFCC66,&HFFFF66
'&HFF0099,&HFF3399,&HFF6699,&HFF9999,&HFFCC99,&HFFFF99
'&HFF00CC,&HFF33CC,&HFF66CC,&HFF99CC,&HFFCCCC,&HFFFFCC
'&HFF00FF,&HFF33FF,&HFF66FF,&HFF99FF,&HFFCCFF,&HFFFFFF
'
'
'

' Function to build the Web Safe palette
' Not used in this version
' Required for 8 bit support in next release.
Sub sMakeWebSafePalette()
Dim varArray() As Byte
Dim x As Long, y As Long
Dim strPalette As String
Dim StrTemp As String
Dim strConvert As String


strPalette = ",000000 ,003300 ,006600 ,009900 ,00CC00 ,00FF00 ,000033 ,003333 ,006633 ,009933 ,00CC33 ,00FF33,000066 ,003366 ,006666 ,009966 ,00CC66 ,00FF66 ,000099 ,003399 ,006699 ,009999 ,00CC99 ,00FF99 ,0000CC ,0033CC ,0066CC ,0099CC ,00CCCC ,00FFCC ,0000FF ,0033FF ,0066FF ,0099FF ,00CCFF ,00FFFF ,330000 ,333300 ,336600 ,339900 ,33CC00 ,33FF00 ,330033 ,333333 ,336633 ,339933 ,33CC33 ,33FF33 ,330066 ,333366 ,336666 ,339966 ,33CC66 ,33FF66 ,330099 ,333399 ,336699 ,339999 ,33CC99 ,33FF99 ,3300CC ,3333CC ,3366CC ,3399CC ,33CCCC ,33FFCC ,3300FF ,3333FF ,3366FF ,3399FF ,33CCFF ,33FFFF ,660000 ,663300 ,666600 ,669900 ,66CC00 ,66FF00 ,660033 ,663333 ,666633 ,669933 ,66CC33 ,66FF33 ,660066 ,663366 ,666666 ,669966 ,66CC66 ,66FF66 ,660099 ,663399 ,666699 ,669999 ,66CC99 ,66FF99 ,6600CC ,6633CC ,6666CC ,6699CC ,66CCCC ,66FFCC ,6600FF ,6633FF ,6666FF ,6699FF ,66CCFF ,66FFFF ,990000 ,993300 ,996600 ,999900 ,99CC00 ,99FF00"
strPalette = strPalette & ",990033 ,993333 ,996633 ,999933 ,99CC33 ,99FF33,990066 ,993366 ,996666 ,999966 ,99CC66 ,99FF66 ,990099 ,993399 ,996699 ,999999 ,99CC99 ,99FF99 ,9900CC ,9933CC ,9966CC ,9999CC ,99CCCC ,99FFCC  ,9900FF ,9933FF ,9966FF ,9999FF ,99CCFF ,99FFFF,CC0000 ,CC3300 ,CC6600 ,CC9900 ,CCCC00 ,CCFF00 ,CC0033 ,CC3333 ,CC6633 ,CC9933 ,CCCC33 ,CCFF33 ,CC0066 ,CC3366 ,CC6666 ,CC9966 ,CCCC66 ,CCFF66 ,CC0099 ,CC3399 ,CC6699 ,CC9999 ,CCCC99 ,CCFF99 ,CC00CC ,CC33CC ,CC66CC ,CC99CC ,CCCCCC ,CCFFCC ,CC00FF ,CC33FF ,CC66FF ,CC99FF ,CCCCFF ,CCFFFF ,FF0000 ,FF3300 ,FF6600 ,FF9900 ,FFCC00 ,FFFF00 ,FF0033 ,FF3333 ,FF6633 ,FF9933 ,FFCC33 ,FFFF33 ,FF0066 ,FF3366 ,FF6666 ,FF9966 ,FFCC66 ,FFFF66 ,FF0099 ,FF3399 ,FF6699 ,FF9999 ,FFCC99 ,FFFF99 ,FF00CC ,FF33CC ,FF66CC ,FF99CC ,FFCCCC ,FFFFCC ,FF00FF ,FF33FF ,FF66FF ,FF99FF ,FFCCFF ,FFFFFF"

ReDim varArray(3 * 256)

' Loop indexes for arrays
y = 0
x = 1

' While not past end of the string
Do 'While Mid(strTemp, X, 3) <> ""
StrTemp = Mid(strPalette, x, 1)

Select Case StrTemp
Case ""
' All done
Exit Do

Case ","
' Grab next 6 hex chars as RGB
strConvert = "&H" & Mid(strPalette, x + 1, 2)
varArray(y) = Val(strConvert)

strConvert = "&H" & Mid(strPalette, x + 1 + 2, 2)
varArray(y + 1) = Val(strConvert)

strConvert = "&H" & Mid(strPalette, x + 1 + 4, 2)
varArray(y + 2) = Val(strConvert)

x = x + 6
y = y + 3

Case Else
End Select

x = x + 1
Loop While Mid(strPalette, x, 3) <> ""


'vararray(y) =
'Dim quad(0 To 255) As RGBQUAD
'lngRet = GetDIBColorTable(hDC, 0, 256, quad(0))


y = 0
For x = 0 To 215 '55
    
    'bmh256.bmiColors(x).rgbRed = varArray(y)
    
    y = y + 1
    
    'bmh256.bmiColors(x).rgbGreen = varArray(y)
    
    y = y + 1
    
    'bmh256.bmiColors(x).rgbBlue = varArray(y)
   
        
    'bmh256.bmiColors(x).rgbReserved = 0
    
    y = y + 1
Next x


End Sub


' Function not used here.
' Used in Access to Grab current palette
Public Sub sGrabPalette()

' The Image Control's ObjectValue prop
' contains 8 more bytes than 256*4 RGB quads.
' I haven't had a chance to look at it yet.

Dim varArray() As Byte
Dim varTemp() As Byte
Dim x As Long, y As Long

x = LenB(mImageCtl.ObjectPalette)
ReDim varArray(x - 1)
ReDim varTemp(x - 1)

varTemp = mImageCtl.ObjectPalette



' Skip first 4 bytes..not a a Palette entry

apiCopyMemory varArray(0), varTemp(4), x ' - 8

y = 0
For x = 0 To 255
    
    'bmh256.bmiColors(x).rgbRed = varArray(y)
    
    y = y + 1
    
    'bmh256.bmiColors(x).rgbGreen = varArray(y)
    
    y = y + 1
    
    'bmh256.bmiColors(x).rgbBlue = varArray(y)
   
    y = y + 1
    
    'bmh256.bmiColors(x).rgbReserved = 0
    
    y = y + 1
Next x


End Sub


' Function to make sure we handle System Colors
Private Function ConvertSystemColor(lngColor As Long) As Long

'Dim lngColor As Long
Dim RGBRed As Long, RGBGreen As Long, RGBBlue As Long
 
' Set to Access Form Background Color
'lngColor = -2147483633
 
' Check and see if MSB is set in High byte
If lngColor And &H80000000 Then
    ' Strip off any bits set in High Byte
    ' GetSysColor function retrieves the current color of
    ' the specified display element. In this case it is the
    ' value of 15 -> vbButtonFace    0x8000000F
    lngColor = GetSysColor(lngColor And &HFFFFFF)
End If
 
' Generate individual RGB values.
RGBRed = lngColor And &HFF
RGBGreen = (lngColor \ &H100&) And &HFF
RGBBlue = (lngColor \ &H10000) And &HFF


Dim temphDC As Long
temphDC = apiGetDC(0&)
'hDC = apiCreateCompatibleDC(temphDC)
ConvertSystemColor = GetNearestColor(temphDC, lngColor)
'Debug.Print ""
'Debug.Print "SysColor:" & ConvertSystemColor


apiReleaseDC 0&, temphDC

'ConvertSystemColor = GetNearestColor(hDC, lngColor)
' The result = R(192),G(192),B(192)
' That's our favourite plain old Access GREY!
End Function



